      subroutine addvarfreq(maxnumfreq,numfreq,freqloc,varpos)
 
c     Subroutine to add a variable to the list of variables that require
c     summary statistics.  To be used only in subroutines that are called
c     by subroutines read_model*.  Those routines initialize nfreq() which
c     point to the position in freqloc where variables for the currently
c     relevant model statement appear.
c
c     The variable to be added should be identified by its level and
c     position relative the the first variable of that (data structure and)
c     level: level*(nold+1)+varpos.  The data structure is not recorded;
c     it is known from elsewhere.
c
c     This routine only adds variables if there is space, i.e., if
c     numfreq<maxnumfreq.
c
c     Constantijn Panis, 6 September 2002
 
      implicit none
      integer maxnumfreq,numfreq,freqloc(maxnumfreq),varpos,n
 
      if(numfreq.ge.maxnumfreq)goto 999
 
c     Only add if not already tracked; first relevant freqloc=-1.
c     Search backward through freqloc for occurrence.
      n=numfreq
  100 if(freqloc(n).eq.-1)then
         numfreq=numfreq+1
         freqloc(numfreq)=varpos
      elseif(freqloc(n).ne.varpos)then
         n=n-1
         if(n.gt.0)goto 100
      endif
 
  999 return
      end
