      subroutine blowup(task,dim,ndraw,small,big)
 
c     Subroutine to:
c        task = 1: expand a covariance matrix to account for independent
c                  draws.
c               2: collapse derivatives and accumulate them into small.
c
c     This routine accumulates, not assigns.
c
c     Constantijn Panis,  3 December 2001
 
      implicit none
      integer task,dim,ndraw,bigdim,i,j,n
      double precision small(dim,dim),big(ndraw*dim,ndraw*dim),dprowsum
 
      bigdim=ndraw*dim
      n=dim*bigdim+dim
 
      if(task.eq.1)then
c        Expand covariance matrix
         do 110 i=1,dim
            do 120 j=1,dim
               call addrow(small(i,j),big(i,j),ndraw,n)
  120       continue
  110    continue
      else
c        Collapse derivatives:
         do 210 i=1,dim
            do 220 j=1,dim
               small(i,j)=small(i,j)+dprowsum(big(i,j),n,ndraw)
  220       continue
  210    continue
      endif
 
  999 return
      end
