      character*12 function branchstring(level,branch)
 
c     Character function that returns the string equivalent of a branch
c     tree.  For example, suppose there are 4 levels and we are currently
c     dealing with branch 1-2-3-4 (first level always 1, second level 2,
c     third level 3, fourth level 4).  This function returns '1-2-3-4'.
c
c     If 12 characters is insufficient to store the entire branch tree,
c     branchstring will be truncated.
c
c     Constantijn Panis, 14 February 2000
c     Last change: include "1-" for the first level.
 
      implicit none
      integer level,branch(level),ll,trm
      character string*12,i2c*12
 
      string='1'
      do 100 ll=2,level
         string=string(1:trm(string))//'-'//i2c(branch(ll),0)
  100 continue
      branchstring=string
 
      return
      end
