      subroutine c2dp(a,x,status)
 
c     Subroutine to convert character string into double precision
c     number.
c
c     Arguments:
c        a       [in] character string; must be left-flush
c        x      [out] equivalent double precision
c        status [out] 0 = all went OK
c                     1 = character string was not an integer
c
c     Bug:  Integers are sometimes read in as not-quite integers.
c     For example, 2.00 is interpreted as something slightly
c     different from 2.
c
c     Constantijn Panis, 17 November 1999
 
      implicit none
      double precision x
      character a*(*)
      integer status
      double precision sign
      integer length,expo,begin,i,itmp,match
      character str15*15
      logical numeric
      data str15/'0123456789.dDeE'/
 
      status=1
      length=len(a)
      if(length.eq.0)goto 999
      sign=1.d0
      expo=0
      x=0.d0
      begin=1
      if(a(begin:begin).eq.'-')then
         if(length.eq.1)goto 999
         sign=-1
         begin=2
      elseif(a(begin:begin).eq.'+')then
         if(length.eq.1)goto 999
         begin=2
      endif
 
c     If first character is numerical continue:
      if(numeric(a(begin:begin)))goto 200
c     The only other allowable possibility is a '.':
      if(a(begin:begin).ne.'.')goto 999
c     But don't accept missing values:
      if(begin.eq.length)goto 999
c     Only accept numerical value as subsequent character:
      if(.not.numeric(a(begin+1:begin+1)))goto 999
 
  200 do 210 i=begin,length
         call char1match(a(i:i),str15,15,match)
         if(match.eq.0)then
            goto 999
         elseif(match.le.10)then
            x=10.d0*x+dble(match-1)
         elseif(match.eq.11)then
c           Decimal point
            expo=i
         else
c           Exponent
            if(expo.gt.0)expo=expo-i+1
            if(i.eq.length)goto 999
            call c2i(a(i+1:length),itmp,status)
            if(status.ne.0)goto 999
            expo=expo+itmp
            goto 220
         endif
  210 continue
      if(expo.gt.0)expo=expo-length
  220 x = sign*x*10.d0**expo
      status=0
 
  999 return
      end
