      subroutine checkdims(ne,neh,nel,nep,nec,neb,nen,nepo,neml,nneml,
     *   numdist,numnest,nested,distdim,distyp,lamtyp,ndraw,iid4,
     *   scrdim,dimscr)
 
c     General subroutine to check that all kinds of arrays won't
c     go out of bounds in ithobs.
c
c     This routine is called by prepscratch.  Its outcome, scrdim,
c     if verified in figure_pos (called by amlfunc_).
c
c     Constantijn Panis, 11 November 2002
c     Last change: Poisson
 
      implicit none
      integer ne,neh,nel,nep,nec,neb,nen,nepo,neml,nneml,numdist,
     *   numnest,nested(numdist),distdim(numdist),distyp(numdist),
     *   lamtyp(numdist,8),ndraw(numdist),scrdim,dimscr,
     *   dim,bigdim,sumbigintdim,dimlam,dimarar,dimii,i,
     *   distype,lamtypdim
      logical iid4
 
c     Dimension of residual matrices and residual load matrices:
      sumbigintdim=0
      dimlam=0
      dimarar=0
      dimii=0
      do 100 i=1,numdist
         dim=distdim(i)
         bigdim=dim*ndraw(i)
         if(nested(i).gt.0)then
            sumbigintdim=sumbigintdim+bigdim
            dimii=dimii+bigdim*bigdim
         endif
         distype=abs(distyp(i))
         if(mod(distype,10).eq.2.or.mod(distype,10).eq.3)
     *      dimarar=dimarar+bigdim*bigdim
         dimlam=dimlam+lamtypdim(neh,bigdim,lamtyp(i,1))
         dimlam=dimlam+lamtypdim(nel,bigdim,lamtyp(i,2))
         dimlam=dimlam+lamtypdim(nep,bigdim,lamtyp(i,3))
         dimlam=dimlam+lamtypdim(nec,bigdim,lamtyp(i,4))
         dimlam=dimlam+lamtypdim(neb,bigdim,lamtyp(i,5))
         dimlam=dimlam+lamtypdim(nen,bigdim,lamtyp(i,6))
         dimlam=dimlam+lamtypdim(nepo,bigdim,lamtyp(i,7))
         dimlam=dimlam+lamtypdim(nneml,bigdim,lamtyp(i,8))
  100 continue
 
c     See figure_pos for all arrays that are allocated for each
c     observation in turn:
      dimscr = 2*nep*nep*(1+numnest) + 4*(nel+nep)*(1+numnest) +
     *   2*nec + 2*nec*nec*(1+numnest) + 2*sumbigintdim*nec +
     *   2*ne + 2*(nneml-neml) + 2*dimarar + 2*dimii*numnest +
     *   dimlam + 2*nec + max(nep,sumbigintdim)*nec +
     *   sumbigintdim*(1+2*numnest) + nep
c     sigl4l6, dsigl4l6, and ddsigl4l6 only if there is correlation
c     between probit and continuous outcomes.
      if(nec.gt.0.and.nep.gt.0.and..not.iid4)dimscr =
     *   dimscr + (1+2*numnest)*numdist*nep*nec
c     dlam and ddlam only needed if any lambda is estimated.  However,
c     iflam may be false for observation 1 but true for observation 2
c     (see samples\Chapter5\hskedas2).  The cost of allocating space is
c     low (except when sparsity=no).
      dimscr=dimscr+2*dimlam*numnest
 
c     How much maximum space is needed?
      scrdim = max(scrdim,dimscr)
 
      return
      end
 
