      subroutine defaults(convcrit,stprng,ipt,jpt,version,output,nobs,
     *   useid,useobs,prof,sparsity,numsearch,maxiter,wghtpos,
     *   check99999,posdef,ieee,title,scrfile,gridfile)
 
c     This subroutine sets various options equal to their defaults.
c
c     Constantijn Panis, 27 November 2002
c     Last change: version
 
      implicit none
      double precision convcrit(4)
      integer output(10),stprng(3),ipt,jpt,version,nobs,useid,useobs,
     *   prof,sparsity,numsearch,maxiter,wghtpos,posdef
      logical check99999,ieee
      character title*80,scrfile*128,gridfile*128
 
c     Output options in integer array output (default):
c           1 = file info level                 (5)
c           2 = screen info level               (3)
c           3 = gradient check                  (0)
c           4 = Hessian matrix                  (0)
c           5 = variance-covariance matrix      (0)
c           6 = correlation matrix              (0)
c           7 = table format                    (0)
c           8 = starting value format           (0)
c           9 = Huber-corrected standard errors (0)
c          10 = numerical standard errors       (0)
 
      ipt=5
      jpt=3
      output(1)=ipt
      output(2)=jpt
      call zeroint(8,output(3))
 
c     Version is the version according to which aML needs to behave,
c     not the version it actually is.  Included for backward compatibility.
c     As of 11/27/2002, version=1 only affects negative binomials.
      version=2
 
c     Convergence criteria (currently all "or")
c           weighted gradient norm < .1         (enabled)
c           relative function improvement < -1  (disabled)
c           gradient norm < -1                  (disabled)
c           relative step size < -1             (disabled)
      call put(-1.d0,convcrit,4)
      convcrit(1)=.1d0
 
c     Number of observations: 0 (i.e., all)
      nobs=0
      useid=0
      useobs=0
 
c     Proficiency = novice;
      prof=1
 
c     sparsity = yes;
      sparsity=1
 
c     numerical search=no;
      numsearch=0
 
c     Number of iterations: 40
      maxiter=40
 
c     step range: 1/1024 to 16 (do not save step size)
      stprng(1)=-10
      stprng(2)=4
      stprng(3)=0
 
c     Variable position for weighted estimation:
      wghtpos=0
 
c     Check that spline durations are not 99999 when in the model, and
c     that they are 99999 when not in the model:
      check99999=.true.
 
c     Automatically ensure that correlation matrices are positive
c     definite by reducing correlations proportionally (see prepcov)
      posdef=1
 
c     Write out IEEE floating point warnings (inexact, underflow,
c     overflow).  Only relevant on SUN.
      ieee=.false.
 
c     Title: ' '  (no title)
      title = ' '
 
c     Filename for scratch data:  ' ' (machine default)
      scrfile = ' '
 
c     Filename for grid search output (machine default, outputfile)
      gridfile = ' '
 
      return
      end
