      subroutine diagcovar(ne,dim,lamtyp,lampos,ndraw,dimlam,lam,ibnnid)
 
c     Subroutine to falsify potential independence of a covariance matrix,
c     based on the properties of a load matrix Lambda.
c
c     Key is that Lambda has nonzero elements in multiple rows within a draw
c     block.  (Lambda has ndraw blocks of dimension nep by dim.)
c
c     Arguments:
c        ibnnid [out] if the resulting covariance matrix is diagonal,
c                     ibnnid remains .true., otherwise false.
c                     (ibnnid = Independent But Not Necessarily IDentical.)
c
c     Constantijn Panis, 17 October 2002
c     Taken directly from compsig44 of version 3.05.
 
      implicit none
      integer ne,dim,lamtyp,lampos,ndraw,dimlam,draw,pos,nonzero,ie
      double precision lam(dimlam)
      logical ibnnid,rowallzero
 
      if(.not.ibnnid)goto 999
 
      if(lamtyp.eq.0)then
         do 100 draw=1,ndraw
            pos=lampos+1+(draw-1)*ne*dim
            nonzero=0
            do 110 ie=1,ne
               if(.not.rowallzero(lam(pos),ne,dim))then
                  nonzero=nonzero+1
                  if(nonzero.gt.1)then
                     ibnnid=.false.
                     goto 999
                  endif
               endif
               pos=pos+1
  110       continue
  100    continue
      elseif(lamtyp.eq.1)then
         goto 999
      elseif(lamtyp.eq.4)then
         do 200 draw=1,ndraw
            pos=lampos+1
            nonzero=0
            do 210 ie=1,ne
               if((int(lam(pos))-1)/dim+1.eq.draw)then
                  nonzero=nonzero+1
                  if(nonzero.gt.1)then
                     ibnnid=.false.
                     goto 999
                  endif
               endif
               pos=pos+1
  210       continue
  200    continue
      endif
 
  999 return
      end
