      double precision function dprowmin(a,nrow,ncol)
 
c     Function to compute the minimum of row elements of matrix a.
c     The minimum of the first row is computed; should the minimum of
c     row i be desired, use the routine as follows:
c        dprowmin(a(i,1),nrow,ncol)
c
c     If ncol=0, this function returns dprowmin=0.
c
c     Constantijn Panis,  27 November 2002
 
      implicit none
      integer nrow,ncol,i
      double precision a(nrow*ncol),temp
 
      if(ncol.eq.0)then
         dprowmin=0.d0
         goto 999
      endif
 
      temp=a(1)
      do 100 i=nrow+1,nrow*ncol,nrow
         temp = min(temp,a(i))
  100 continue
      dprowmin=temp
 
  999 return
      end
