      subroutine etomdy(edate,month,day,year)
 
c     Subroutine to convert an elapsed date (number of days since 1/1/1960)
c     into month,day, and year.
c
c     edate   [in] elapsed date (integer; days since 1/1/1960)
c     month  [out] month of the year (integer)
c     day    [out] day of the month (integer)
c     year   [out] year (integer; 4 digits)
c
c     Note the existence of mdytoe, which maps the inverse.
c
c     This routine is based on Stata-provided etomdy.ado.
c
c     Constantijn Panis, 9 November 1999
 
      implicit none
      integer edate,month,day,year,temp1,temp2,mowrk
 
      temp2 = 4*(edate+2505504)/146097
      temp1 = edate + 2505504 - (146097*temp2+3)/4
      year = 4000*(temp1+1)/1461001
      temp1 = temp1 - 1461*year/4 + 31
      mowrk = 80*temp1/2447
      day = temp1 - 2447*mowrk/80
      temp1 = mowrk/11
      month = mowrk + 2 - 12*temp1
      year = 100*(temp2-49) + year + temp1
 
      return
      end
 
