      subroutine figdata1(levelmax,nb2,nbdim,datadim,neh,neint,nfull,
     *   nold,maxmspl,vdimmax,maxnfreq,nummodel,numspl,maxref,
     *   numpar,maxmeno,maxnmapmoel,numdist,sumdim,maxdraws,draws,draw,
     *   ndraw,numrset,maxnode,maxds,nngammax,rsh3max,rsh4max,
     *   rsh5max,maxxnode,maxfreqcat,xdim,vdim,nmapmoel,plusmin,ipt,jpt,
     *   iobs,id,nb,branch,struc,dimxpntr,xpntr,nxold,namepntr,
     *   fulltype,moel,moelpntr,mapmoel,datas,minlnl,modeltype,
     *   mdllvl,strctre,intpnts,dimused,distdim,distyp,lamtyp,lamrow,
     *   sparsity,distpos,rsetbegin,rsetnum,beginspl,
     *   nodepos,numnodes,spltype,parpos,parref,rsetref,resref,splref,
     *   nfreq,freqloc,freqcat,freqs,originstats,rsetstats,x,
     *   v,splineorigin,xnode,iflam,detail,check99999,splname,
     *   resname,oldname)
 
c     Subroutine to figure out exactly which regressors, residuals,
c     splines etc enter each HAZARD episode, and to create the scratch
c     data set.
c
c     Constantijn Panis, 16 October 2001
c     Last change:  Adapt to nsb issue in version 2.60
 
      implicit none
c     Integer scalars use in dimensioning (in this or other routines):
      integer levelmax,nb2,nbdim,datadim,neh,neint,nfull,nold,
     *   maxmspl,vdimmax,maxnfreq,nummodel,numspl,maxref,numpar,
     *   maxmeno,maxnmapmoel,numdist,sumdim,maxdraws,numrset,
     *   maxnode,maxds,nngammax,rsh3max,rsh4max,rsh5max,
     *   maxxnode,maxfreqcat,xdim,vdim,nmapmoel,plusmin,ipt,jpt
c     Branch control, data:
      integer iobs,id,nb(nbdim,2),branch(levelmax),branchnum,
     *   struc(nb2),dimxpntr,xpntr(2:dimxpntr,nb2),
     *   nxold(levelmax,datadim),namepntr(levelmax,datadim)
c     Model specifications:
      integer fulltype(nfull),moel(maxmeno),moelpntr(nummodel),
     *   mapmoel(maxnmapmoel),datas(nummodel),minlnl(nummodel),
     *   modeltype(nummodel),mdllvl(nummodel),strctre(nummodel)
c     Residual structures:
      integer intpnts(sumdim),dimused(sumdim),distdim(numdist),
     *   distyp(numdist),lamtyp(numdist),lamrow(numdist),sparsity,
     *   distpos(numdist),draws(maxdraws,numdist),draw(numdist,neh),
     *   ndraw(numdist)
c     Model element definitions:
      integer rsetbegin(numrset),rsetnum(numrset),
     *   beginspl(numspl),nodepos(numspl),numnodes(numspl),
     *   spltype(numspl),parpos(numpar),parref(maxref),rsetref(maxref),
     *   resref(maxref),splref(maxref),nfreq(nummodel),
     *   freqloc(maxnfreq),freqs(maxfreqcat,maxnfreq)
      double precision originstats(5,numspl),rsetstats(5,nfull)
      real x(xdim),v(vdimmax),splineorigin(maxmspl),xnode(maxxnode),
     *   freqcat(maxfreqcat,maxnfreq)
      logical iflam(numdist),detail,check99999
      character splname(numspl)*12,resname(sumdim)*8,
     *   oldname(nold)*8
c     Locally required scalars and functions:
      integer meno,pos,num,rs3,rs4,rs5,nngam,nds,select,censor,ib2,ie,
     *   outlvl,durvar,timevar,nsb,nl,nu,ds,m,status,
     *   splinedone,nmbrnch,trm
      real outcome,durvars(2)
      character string*60,idstring*60
 
      ie=0
c     The first 4*neh positions in v (starting at vpntr1) are
c     for censor, nsb, nl, and nu (neh series of four variables):
      vdim=vdim+4*neh
 
c     Loop over all model specifications, and within those over all
c     possible branches at the outcome level.
      do 100 m=1,nummodel
c        Is it a hazard model?
         if(modeltype(m).ne.1)goto 100
c        Does it apply to the numerator or denominator that is
c        currently dealt with?  (See figure_model.)
         if(minlnl(m).eq.0.and.plusmin.lt.0)goto 100
         if(minlnl(m).eq.1.and.plusmin.ge.0)goto 100
 
c        What rank number data structure is that model?
         ds=strctre(m)
 
         select=moel(moelpntr(m))
 
c        Loop over outcomes:
         ib2=1
         branchnum=0
  120    call nextbranch(1,mdllvl(m),branch,nbdim,nb,branchnum)
         if(branchnum.eq.0)goto 100
c        Is this data structure modeled?
         if(mdllvl(m).gt.1)then
            ib2=branch(2)
            if(struc(ib2).ne.datas(m))goto 120
         endif
 
c        Careful: censor cannot be moved above label 120.
         meno=moelpntr(m)
         select=moel(meno)
         censor=moel(meno+1)
         durvar=moel(meno+2)
         timevar=moel(meno+3)
         meno=meno+4
 
         if(select.ne.0)then
            call evalexpr(1,maxxnode,xdim,abs(select),nold,levelmax,
     *         mdllvl(m),nbdim,nb,branch,xpntr(2,ib2),nxold(1,ds),
     *         namepntr(1,ds),xnode,x,outcome,oldname,
     *         struc(ib2),iobs,id,ipt,jpt,status)
            if(status.gt.0)stop
            if(outcome.ne.0..and.outcome.ne.1.)call bug(ipt,jpt)
            if(select.gt.0.and.outcome.eq.0.)goto 120
            if(select.lt.0.and.outcome.eq.1.)goto 120
         endif
 
         ie=ie+1
         neint=-abs(neint)
 
c        Model applies to branch(mdllvl), but time-varying covariates,
c        if any, require a step down into branch(mdllvl+1)=1.
         if(timevar.gt.0)branch(mdllvl(m)+1)=1
 
         nds=0
         splinedone=0
         nngam=0
         rs3=0
         rs4=0
         rs5=0
 
c        Check in ithobs:
         vdim=vdim+1
         v(vdim)=real(ie)
 
c        Number of subbranches, if any. Relevant only if there are
c        time-varying variables.
         if(timevar.gt.0)then
            nsb=nmbrnch(mdllvl(m),branch,mdllvl(m)+1,nbdim,nb)
            if(nsb.eq.0)goto 810
         else
            nsb=1
         endif
 
c        Censor variable (if hazard models weren't the first to appear
c        in the scratch data, vpntr1-1+ie would be required):
         call evalexpr(1,maxxnode,xdim,censor,nold,levelmax,
     *      mdllvl(m),nbdim,nb,branch,xpntr(2,ib2),nxold(1,ds),
     *      namepntr(1,ds),xnode,x,outcome,oldname,struc(ib2),
     *      iobs,id,ipt,jpt,status)
         if(status.gt.0)stop
         if(outcome.ne.0..and.outcome.ne.1.)goto 820
         censor=int(outcome)
 
c        Place time marks in v.  If there are no time-varying variables,
c        the time marks are zero, durvar1, and durvar2.  If there are
c        time-varying variables, they follow from the timevar variable,
c        with possibly another mark inserted by durvar1. Also check that
c        the highest time mark is at least as high as durvar2. If time
c        marks go beyond durvar2, truncate them.
         call timemarks(mdllvl(m),levelmax,maxxnode,nold,nxold(1,ds),
     *      namepntr(1,ds),xdim,vdimmax,vdim,nsb,nl,nu,nbdim,nb,censor,
     *      durvar,timevar,durvars,ipt,jpt,struc,iobs,id,branch,
     *      xpntr(2,ib2),nb2,xpntr,xnode,x,v,oldname)
         v(4*ie-3)=real(censor)
         v(4*ie-2)=real(nsb)
         v(4*ie-1)=real(nl)
         v(4*ie)=real(nu)
 
c        Set up regressor sets, duration splines and integrated
c        residuals.  Distinguish between situation where time-
c        varying covariates are allowed (timevar>0) and not.
         outlvl=mdllvl(m)
         if(timevar.gt.0)outlvl=outlvl+1
c        Careful: figdata will prepare data for nsb branches, even if
c        fewer are needed (nu<nsb).  Careful in mapmodel.
         call figdata(1,levelmax,nbdim,nb,xdim,vdim,maxxnode,
     *      struc(ib2),modeltype(m),1,mdllvl(m),outlvl,nsb,
     *      vdimmax,neint,maxmeno,meno,moel,maxnmapmoel,mapmoel,
     *      nmapmoel,numdist,sumdim,intpnts,distdim,maxdraws,draws,
     *      draw(1,ie),ndraw,dimused,distyp,lamtyp,lamrow,sparsity,
     *      distpos,xpntr(2,ib2),nb2,xpntr,nfull,fulltype,maxref,parref,
     *      rsetref,resref,numpar,parpos,numrset,rsetbegin,rsetnum,
     *      numspl,beginspl,nodepos,numnodes,spltype,
     *      splref,maxmspl,nds,nngam,rs3,rsh3max,rs4,rsh4max,rs5,
     *      rsh5max,1,splinedone,branch,namepntr(1,ds),nxold(1,ds),
     *      nold,originstats,rsetstats,x,v,0.,xnode,splineorigin,
     *      durvars(2),'12345678',oldname,iflam,detail,check99999,
     *      splname,resname,0,0,0,iobs,id,ipt,jpt)
 
c        Check that there is at least one spline that starts at or before
c        the beginning of the episode and copy the spline origins:
         if(splinedone.eq.0)goto 830
c        Make sure all slopes will fit in gamma and all nodes in nodes:
         nngammax=max(nngammax,nngam)
         if(nngam.gt.maxnode)call
     *      maxexceed('maxnode',nngam,maxnode,ipt,jpt)
c        In subroutine simhaz, ds is a matrix of derivatives of the baseline
c        survivor function wrt all slopes.  Make sure its dimension is ok.
         if((nu+1)*nngam.gt.maxds)call
     *      maxexceed('maxds',(nu+1)*nngam,maxds,ipt,jpt)
 
c        Copy spline origins into the data scratch array:
         call copy4(splineorigin,v(vdim+1),nds)
         vdim=vdim+nds
 
         if(detail)then
            num=nfreq(m)/(maxnfreq+1)
            pos=mod(nfreq(m),maxnfreq+1)
            if(num.lt.4)goto 120
c           Keep track of summary statistics of length of spell:
            if(censor.eq.0)then
               call figure_freq(durvars(1),freqcat(1,pos),
     *            freqs(1,pos),maxfreqcat)
               call figure_freq(durvars(2),freqcat(1,pos+1),
     *            freqs(1,pos+1),maxfreqcat)
               call figure_freq(durvars(2)-durvars(1),
     *            freqcat(1,pos+2),freqs(1,pos+2),maxfreqcat)
            else
               call figure_freq(durvars(2),freqcat(1,pos+3),
     *            freqs(1,pos+3),maxfreqcat)
            endif
c           Keep track of frequency distributions of other used variables:
            num=num-4
            pos=pos+4
            if(num.gt.0)call trackfreq(num,maxfreqcat,freqloc(pos),
     *         freqcat(1,pos),freqs(1,pos),nbdim,nb,branch,
     *         xpntr(2,ib2),nxold(1,ds),nold,x)
         endif
 
c        Go to the next outcome:
         goto 120
  100 continue
      goto 999
 
  810 string=idstring(struc(ib2),id,iobs,mdllvl(m),branch)
      if(ipt.gt.0)call wrapstring(8,0,72,0,1,'ERROR:  a hazard '//
     *   'model ('//string(1:trm(string))//') cannot be evaluated '//
     *   'because there are zero subbranches. (If there are no time-'//
     *   'varying covariates, remove the TIMEMARKS statement.')
      if(jpt.gt.0)call wrapstring(6,0,72,0,1,'ERROR:  a hazard '//
     *   'model ('//string(1:trm(string))//') cannot be evaluated '//
     *   'because there are zero subbranches. (If there are no time-'//
     *   'varying covariates, remove the TIMEMARKS statement.')
      stop
  820 string=idstring(struc(ib2),id,iobs,mdllvl(m),branch)
      if(ipt.gt.0)then
         call wrapstring(8,0,72,0,1,'ERROR: the censor variable for '//
     *      'a hazard model ('//string(1:trm(string))//
     *      ') is neither zero nor one:')
         call writeexpr(111,8,maxxnode,xdim,levelmax,nbdim,
     *      -abs(censor),nb,branch,xpntr(2,ib2),1,nold,nxold(1,ds),
     *      namepntr(1,ds),-1,outcome,xnode,x,oldname,struc(ib2))
      endif
      if(jpt.gt.0)then
         call wrapstring(6,0,72,0,1,'ERROR: the censor variable for '//
     *      'a hazard model ('//string(1:trm(string))//
     *      ') is neither zero nor one:')
         call writeexpr(111,6,maxxnode,xdim,levelmax,nbdim,
     *      -abs(censor),nb,branch,xpntr(2,ib2),1,nold,nxold(1,ds),
     *      namepntr(1,ds),-1,outcome,xnode,x,oldname,struc(ib2))
      endif
      stop
  830 string=idstring(struc(ib2),id,iobs,mdllvl(m),branch)
      if(ipt.gt.0)call wrapstring(8,0,72,0,1,'ERROR: there is no '//
     *   'duration spline operating at the beginning of a hazard '//
     *   'spell ('//string(1:trm(string))//').  At least one '//
     *   'duration spline must apply.')
      if(jpt.gt.0)call wrapstring(6,0,72,0,1,'ERROR: there is no '//
     *   'duration spline operating at the beginning of a hazard '//
     *   'spell ('//string(1:trm(string))//').  At least one '//
     *   'duration spline must apply.')
      stop
  999 return
      end
