      subroutine figdata4(levelmax,nbdim,nb,nb2,nep,neint,nfull,
     *   maxxnode,datadim,nummodel,mdllvl,maxmeno,maxnmapmoel,numpar,
     *   numrset,numspl,numdist,sumdim,maxdraws,draws,draw,ndraw,
     *   dimused,maxfreqcat,maxnfreq,moel,mapmoel,datas,minlnl,
     *   nmapmoel,plusmin,distdim,intpnts,distyp,lamtyp,lamrow,
     *   sparsity,distpos,moelpntr,maxref,struc,dimxpntr,xpntr,
     *   modeltype,branch,namepntr,nxold,nold,strctre,rsetbegin,
     *   rsetnum,resref,rsetref,beginspl,nodepos,numnodes,spltype,
     *   splref,parref,pardim,parpos,nfreq,freqloc,freqcat,freqs,
     *   rspmax,xdim,vdim,vdimmax,originstats,rsetstats,x,v,xnode,
     *   fulltype,iiffull,ifint4,iftau,iflam,detail,check99999,logit,
     *   resname,oldname,parname,splname,iobs,id,ipt,jpt)
 
c     Subroutine to figure out exactly which thresholds, regressors,
c     integrated residuals and residuals enter each logit/probit
c     outcome, and to create a scratch data set.
c
c     Constantijn Panis, 9 September 2002
c     Last change: Tobits
 
      implicit none
      integer levelmax,nbdim,nb(nbdim,2),nb2,datadim,nummodel,nep,neint,
     *   nfull,maxxnode,mdllvl(nummodel),maxmeno,numpar,maxnmapmoel,
     *   numrset,numspl,numdist,sumdim,dimused(sumdim),distyp(numdist),
     *   lamtyp(numdist),lamrow(numdist),sparsity,distpos(numdist),
     *   maxdraws,draws(maxdraws,numdist),draw(numdist,nep),
     *   ndraw(numdist),maxfreqcat,maxnfreq,moel(maxmeno),meno,nmapmoel,
     *   plusmin,mapmoel(maxnmapmoel),datas(nummodel),minlnl(nummodel),
     *   distdim(numdist),intpnts(sumdim),branch(levelmax),branchnum,
     *   moelpntr(nummodel),maxref,
     *   struc(nb2),dimxpntr,xpntr(2:dimxpntr,nb2),modeltype(nummodel),
     *   namepntr(levelmax,datadim),nxold(levelmax,datadim),nold
      integer fulltype(nfull),iiffull(nfull),strctre(nummodel),
     *   ifint4(numdist),rsetbegin(numrset),rsetnum(numrset),
     *   resref(maxref),rsetref(maxref),
     *   beginspl(numspl),nodepos(numspl),numnodes(numspl),
     *   spltype(numspl),splref(maxref),parref(maxref),pardim(numpar),
     *   parpos(numpar),nfreq(nummodel),freqloc(maxnfreq),
     *   freqs(maxfreqcat,maxnfreq),select,rspmax,rs,resdone,pos,
     *   num,xdim,vdim,vdimmax,ib2,ie,ds,m,iobs,id,ipt,jpt,status,trm
      double precision originstats(5,numspl),rsetstats(5,nfull)
      real x(xdim),v(vdimmax),xnode(maxxnode),outcomes(4),
     *   freqcat(maxfreqcat,maxnfreq),outcome,lowerlimit,upperlimit
      logical iftau,iflam(numdist),detail,check99999,logit
      character resname(sumdim)*8,oldname(*)*8,parname(numpar)*12,
     *   splname(numspl)*12,string*60,idstring*60
 
      ie=0
c     Loop over all model specifications, and within those over all
c     possible branches at the outcome level.
      do 100 m=1,nummodel
c        Is it a logit/probit/Tobit model?
c           41  logit model
c           42  ordered logit model
c           43  probit model
c           44  ordered probit model
c           46  Tobit model
         if(logit)then
            if(modeltype(m).ne.41.and.modeltype(m).ne.42)goto 100
         else
            if(modeltype(m).ne.43.and.modeltype(m).ne.44.and.
     *         modeltype(m).ne.46)goto 100
         endif
c        Does it apply to the numerator or denominator that is
c        currently dealt with?  (See figure_model.)
         if(minlnl(m).eq.0.and.plusmin.lt.0)goto 100
         if(minlnl(m).eq.1.and.plusmin.ge.0)goto 100
 
c        What rank number data structure is that model?
         ds=strctre(m)
 
         select=moel(moelpntr(m))
 
c        Loop over outcomes:
         ib2=1
         branchnum=0
  120    call nextbranch(1,mdllvl(m),branch,nbdim,nb,branchnum)
         if(branchnum.eq.0)goto 100
c        Is this data structure modeled?
         if(mdllvl(m).gt.1)then
            ib2=branch(2)
            if(struc(ib2).ne.datas(m))goto 120
         endif
         if(select.ne.0)then
            call evalexpr(1,maxxnode,xdim,abs(select),nold,levelmax,
     *         mdllvl(m),nbdim,nb,branch,xpntr(2,ib2),nxold(1,ds),
     *         namepntr(1,ds),xnode,x,outcome,oldname,
     *         struc(ib2),iobs,id,ipt,jpt,status)
            if(status.gt.0)stop
            if(outcome.ne.0..and.outcome.ne.1.)call bug(ipt,jpt)
            if(select.gt.0.and.outcome.eq.0.)goto 120
            if(select.lt.0.and.outcome.eq.1.)goto 120
         endif
 
         meno=moelpntr(m)+1
 
         if(modeltype(m).eq.46)then
c           Exit if this is a Tobit outcome that is continuous.
            call filtertobit(levelmax,mdllvl(m),nbdim,nb,branch,
     *         moel,meno,maxmeno,namepntr(1,ds),
     *         nxold(1,ds),nold,xpntr(2,ib2),xdim,maxxnode,x,xnode,
     *         outcome,lowerlimit,upperlimit,oldname,struc(ib2),
     *         iobs,id,ipt,jpt)
            if(lowerlimit.lt.outcome.and.outcome.lt.upperlimit)goto 120
         endif
 
         ie=ie+1
         neint=-abs(neint)
 
c        Make sure there's enough space for outcome number and thresholds:
         if(vdim+3.gt.vdimmax)call
     *      maxexceed('vdimmax',vdim+3,vdimmax,ipt,jpt)
c        Check in ithobs
         vdim=vdim+1
         v(vdim)=real(ie)
 
c        Set up regressor sets and residual structures.
         call figure_tau(levelmax,mdllvl(m),modeltype(m),nbdim,nb,
     *      branch,nfull,numpar,maxref,moel,meno,maxmeno,mapmoel,
     *      nmapmoel,namepntr(1,ds),nxold(1,ds),nold,xpntr(2,ib2),
     *      xdim,parref,parpos,pardim,fulltype,maxxnode,x,v,xnode,
     *      outcome,outcomes,lowerlimit,upperlimit,vdim,iiffull,iftau,
     *      oldname,parname,struc(ib2),iobs,id,ipt,jpt)
 
c        Set up regressor sets and residual structures.
c        Rs keeps track of the number of columns in xbl/xbp that will be
c        needed for scratch space in prep4l/prep4p.  Note that xbl/xbp has a row
c        allocated to each logit/probit outcome, so rs starts counting anew
c        for each logit/probit outcome.  Tobits, if they get this far,
c        are probits.
         rs=0
         resdone=0
         call figdata(1,levelmax,nbdim,nb,xdim,vdim,maxxnode,
     *      struc(ib2),modeltype(m),4,mdllvl(m),mdllvl(m),1,
     *      vdimmax,neint,maxmeno,meno,moel,maxnmapmoel,mapmoel,
     *      nmapmoel,numdist,sumdim,intpnts,distdim,maxdraws,draws,
     *      draw(1,ie),ndraw,dimused,distyp,lamtyp,lamrow,sparsity,
     *      distpos,xpntr(2,ib2),nb2,xpntr,nfull,fulltype,maxref,parref,
     *      rsetref,resref,numpar,parpos,numrset,rsetbegin,rsetnum,
     *      numspl,beginspl,nodepos,numnodes,spltype,splref,
     *      0,0,0,rs,rspmax,rs,rspmax,-1,-1,resdone,-1,branch,
     *      namepntr(1,ds),nxold(1,ds),nold,originstats,rsetstats,
     *      x,v,0.,xnode,0.,0.,'12345678',oldname,iflam,detail,
     *      check99999,splname,resname,0,ie,ifint4,iobs,id,ipt,jpt)
 
c        Make sure a non-integrated residual is specified in probits:
         if((modeltype(m).eq.43.or.modeltype(m).eq.44.or.
     *      modeltype(m).eq.46).and.resdone.eq.0)goto 800
 
         if(detail)then
c           Keep track of summary statistics of selected variables.
            num=nfreq(m)/(maxnfreq+1)
            pos=mod(nfreq(m),maxnfreq+1)
            if(modeltype(m).eq.41.or.modeltype(m).eq.43)then
               if(num.gt.0)call figure_freq(outcome,freqcat(1,pos),
     *            freqs(1,pos),maxfreqcat)
            elseif(modeltype(m).eq.46.and.num.ge.2)then
c              First position for implied categorical (probit) outcomes:
               if(num.gt.0)call figure_freq(outcome,freqcat(1,pos),
     *            freqs(1,pos),maxfreqcat)
c              Leave position open for continuous outcomes (see figdata6):
               num=num-1
               pos=pos+1
            elseif(num.ge.2)then
               call figure_freq(outcomes(1),freqcat(1,pos),
     *            freqs(1,pos),maxfreqcat)
               num=num-1
               pos=pos+1
               call figure_freq(outcomes(2),freqcat(1,pos),
     *            freqs(1,pos),maxfreqcat)
            endif
            num=num-1
            pos=pos+1
            if(num.gt.0)call trackfreq(num,maxfreqcat,freqloc(pos),
     *         freqcat(1,pos),freqs(1,pos),nbdim,nb,branch,
     *         xpntr(2,ib2),nxold(1,ds),nold,x)
         endif
c        Go to the next outcome:
         goto 120
  100 continue
      if(ie.ne.nep)call bug(ipt,jpt)
      goto 999
 
  800 string=idstring(struc(ib2),id,iobs,mdllvl(m),branch)
      if(modeltype(m).eq.46)then
         if(ipt.gt.0)call wrapstring(8,0,72,0,1,'ERROR:  there is no '//
     *      'non-integrated residual in a tobit model ('//
     *      string(1:trm(string))//').')
         if(jpt.gt.0)call wrapstring(6,0,72,0,1,'ERROR:  there is no '//
     *      'non-integrated residual in a tobit model ('//
     *      string(1:trm(string))//').')
      else
         if(ipt.gt.0)call wrapstring(8,0,72,0,1,'ERROR:  there is no '//
     *      'non-integrated residual in a probit model ('//
     *      string(1:trm(string))//').')
         if(jpt.gt.0)call wrapstring(6,0,72,0,1,'ERROR:  there is no '//
     *      'non-integrated residual in a probit model ('//
     *      string(1:trm(string))//').')
      endif
      stop
  999 return
      end
