      subroutine figdata6(levelmax,nbdim,nb,nb2,nummodel,moelpntr,xdim,
     *   vpntr6,vdim,maxxnode,struc,modeltype,mdllvl,strctre,
     *   vdimmax,nec,neint,maxmeno,moel,maxnmapmoel,mapmoel,datas,
     *   minlnl,nmapmoel,plusmin,numdist,sumdim,intpnts,
     *   distdim,maxdraws,draws,draw,ndraw,dimused,distyp,lamtyp,lamrow,
     *   sparsity,distpos,numarma,dimxpntr,xpntr,nfull,fulltype,maxref,
     *   parref,rsetref,resref,numpar,parpos,numrset,rsetbegin,rsetnum,
     *   numspl,beginspl,nodepos,numnodes,spltype,splref,datadim,
     *   rscmax,maxfreqcat,nfreq,maxnfreq,branch,prevbranch,freqloc,
     *   freqcat,freqs,namepntr,nxold,nold,originstats,
     *   rsetstats,x,v,xnode,distvar,oldname,ifint6,
     *   iflam,detail,check99999,splname,resname,iobs,id,ipt,jpt)
 
c     Subroutine to figure out exactly which regressors et cetera
c     enter each CONTINUOUS outcome (including Tobit).
c
c     Constantijn Panis,  13 November 2002
c     Last change:  Tobits
 
      implicit none
      integer levelmax,nbdim,nb(nbdim,2),nb2,nummodel,
     *   moelpntr(nummodel),nec,neint,xdim,vpntr6,vdim,
     *   maxxnode,numdist,sumdim,
     *   intpnts(sumdim),struc(nb2),modeltype(nummodel),
     *   mdllvl(nummodel),strctre(nummodel),
     *   vdimmax,meno,maxmeno,moel(maxmeno),nmapmoel,plusmin,
     *   maxnmapmoel,mapmoel(maxnmapmoel),datas(nummodel),
     *   minlnl(nummodel),distdim(numdist),
     *   maxdraws,draws(maxdraws,numdist),draw(numdist,nec),
     *   ndraw(numdist),dimused(sumdim),ifint6(numdist),numarma,
     *   distyp(numdist),lamtyp(numdist),lamrow(numdist),sparsity,
     *   distpos(numdist),dimxpntr,xpntr(2:dimxpntr,nb2),
     *   nfull,fulltype(nfull),maxref,parref(maxref),rs,rscmax,
     *   rsetref(maxref),resref(maxref),numpar,parpos(numpar),numrset,
     *   rsetbegin(numrset),rsetnum(numrset),
     *   numspl,beginspl(numspl),nodepos(numspl),numnodes(numspl)
      integer spltype(numspl),splref(maxref),datadim,
     *   namepntr(levelmax,datadim),nxold(levelmax,datadim),maxfreqcat,
     *   nold,nfreq(nummodel),maxnfreq,freqloc(maxnfreq),
     *   branch(levelmax),prevbranch(levelmax),branchnum,
     *   freqs(maxfreqcat,maxnfreq),ds,m,n,ib2,ie,resdone,distype,
     *   select,status,num,pos,vp,i,l,iobs,id,ipt,jpt,
     *   trm,absbranch,intmax
      double precision originstats(5,numspl),rsetstats(5,nfull)
      real x(xdim),v(vdimmax),xnode(maxxnode),outcome,realnan,
     *   freqcat(maxfreqcat,maxnfreq),lowerlimit,upperlimit
      character distvar(numdist)*8,oldname(*)*8,splname(numspl)*12,
     *   resname(sumdim)*8,name*8,string*60,idstring*60
      logical iflam(numdist),detail,check99999,realisnan,intvecequal
 
      ie=0
c     The first nec positions in v are for the outcome; for each
c     ARMA distribution another 2*nec are reserved for storage of the
c     a variable indicating blockwise independence (e.g., residuals are
c     autocorrelated withing level 2, but uncorrelated across levels 2)
c     and the timevar variable.  These variables are initialized to NaN
c     and assigned meaningful values by figure_res.
c     Note that nec is the number of all points that actually enter
c     the likelihood.  It was computed in subroutine figure_model.
      call putreal(realnan(),v(vpntr6+nec),2*numarma*nec)
      vdim=vdim+(2*numarma+1)*nec
 
c     Parity check in ithobs:
      vdim=vdim+1
      if(vdim.gt.vdimmax)call maxexceed('vdimmax',vdim,vdimmax,ipt,jpt)
      v(vdim)=real(nec)
 
c     Loop over all model specifications, and within those over all
c     possible branches at the outcome level.
      do 100 m=1,nummodel
c        Is it a continuous model?
         if(modeltype(m).ne.6.and.modeltype(m).ne.46)goto 100
c        Does it apply to the numerator or denominator that is
c        currently dealt with?  (See figure_model.)
         if(minlnl(m).eq.0.and.plusmin.lt.0)goto 100
         if(minlnl(m).eq.1.and.plusmin.ge.0)goto 100
 
c        What rank number data structure is that model?
         ds=strctre(m)
 
         select=moel(moelpntr(m))
 
c        Loop over outcomes:
         ib2=1
         branchnum=0
         call putint(intmax(),prevbranch,levelmax)
  120    call nextbranch(1,mdllvl(m),branch,nbdim,nb,branchnum)
         if(branchnum.eq.0)goto 100
c        Is this data structure modeled?
         if(mdllvl(m).gt.1)then
            ib2=branch(2)
            if(struc(ib2).ne.datas(m))goto 120
         endif
         if(select.ne.0)then
            call evalexpr(1,maxxnode,xdim,abs(select),nold,levelmax,
     *         mdllvl(m),nbdim,nb,branch,xpntr(2,ib2),nxold(1,ds),
     *         namepntr(1,ds),xnode,x,outcome,oldname,
     *         struc(ib2),iobs,id,ipt,jpt,status)
            if(status.gt.0)stop
            if(outcome.ne.0..and.outcome.ne.1.)call bug(ipt,jpt)
            if(select.gt.0.and.outcome.eq.0.)goto 120
            if(select.lt.0.and.outcome.eq.1.)goto 120
         endif
 
         meno=moelpntr(m)+1
 
         if(modeltype(m).eq.46)then
c           Determine tobit outcome; exit if it is censored (probit).
            call filtertobit(levelmax,mdllvl(m),nbdim,nb,branch,
     *         moel,meno,maxmeno,namepntr(1,ds),
     *         nxold(1,ds),nold,xpntr(2,ib2),xdim,maxxnode,x,xnode,
     *         outcome,lowerlimit,upperlimit,oldname,struc(ib2),
     *         iobs,id,ipt,jpt)
            if(lowerlimit.ge.outcome.or.outcome.ge.upperlimit)goto 120
         else
c           Determine outcome:
            call evalexpr(1,maxxnode,xdim,moel(meno),nold,levelmax,
     *         mdllvl(m),nbdim,nb,branch,xpntr(2,ib2),nxold(1,ds),
     *         namepntr(1,ds),xnode,x,outcome,oldname,struc(ib2),
     *         iobs,id,ipt,jpt,status)
            if(status.gt.0)stop
            meno=meno+1
         endif
 
         ie=ie+1
         neint=-abs(neint)
         v(vpntr6+ie-1)=outcome
 
c        Set up regressor sets and residual structures.
         rs=0
         resdone=0
         call figdata(1,levelmax,nbdim,nb,xdim,vdim,maxxnode,
     *      struc(ib2),modeltype(m),6,mdllvl(m),mdllvl(m),1,vdimmax,
     *      neint,maxmeno,meno,moel,maxnmapmoel,mapmoel,nmapmoel,
     *      numdist,sumdim,intpnts,distdim,maxdraws,draws,draw(1,ie),
     *      ndraw,dimused,distyp,lamtyp,lamrow,sparsity,distpos,
     *      xpntr(2,ib2),nb2,xpntr,nfull,fulltype,maxref,parref,rsetref,
     *      resref,numpar,parpos,numrset,rsetbegin,rsetnum,
     *      numspl,beginspl,nodepos,numnodes,spltype,splref,
     *      0,0,0,rs,rscmax,rs,rscmax,-1,-1,resdone,-1,branch,
     *      namepntr(1,ds),nxold(1,ds),nold,originstats,rsetstats,
     *      x,v,v(vpntr6),xnode,0.,0.,distvar,oldname,iflam,
     *      detail,check99999,splname,resname,nec,ie,ifint6,
     *      iobs,id,ipt,jpt)
 
c        Make sure at least one non-integrated residual is specified:
         if(resdone.eq.0)goto 830
 
         if(detail)then
            num=nfreq(m)/(maxnfreq+1)
            pos=mod(nfreq(m),maxnfreq+1)
c           Keep track of outcome
            if(modeltype(m).eq.46)then
c              First position for implied categorical (probit) outcomes
c              (see figdata4):
               num=num-1
               pos=pos+1
            endif
            if(num.gt.0)call figure_freq(outcome,freqcat(1,pos),
     *         freqs(1,pos),maxfreqcat)
            num=num-1
            pos=pos+1
c           Keep track of other variables:
            if(num.gt.0)call trackfreq(num,maxfreqcat,freqloc(pos),
     *         freqcat(1,pos),freqs(1,pos),nbdim,nb,branch,
     *         xpntr(2,ib2),nxold(1,ds),nold,x)
         endif
 
c        Each C/ARMA distribution has a set of nec branch numbers and a set of
c        nec time variables.  Assign branch numbers, so that subroutine arma
c        knows where autocorrelated outcomes begin and end.  (Do it here and
c        not in figure_res in case the C/ARMA residual does not appear in all
c        outcomes.  This is especially likely when there are multiple ARMA
c        distributions, each applicable to a subset of outcomes.)
c        Also check that C/ARMA residuals enter either all or none of the
c        outcomes within the user-specified level.
         if(numarma.gt.0)then
c           The first nec are for the continuous outcome, the next
c           nec for branch numbers, the next nec for time variables.
c           The latter two sets are repeated for each distribution.
            vp=vpntr6+nec+ie-1
            do 160 i=1,numdist
               distype=abs(distyp(i))
               if(mod(distype,10).ne.2.and.mod(distype,10).ne.3)
     *            goto 160
c              This residual is autocorrelated within level l:
               l=distype/1000
               if(realisnan(v(vp+nec)))then
c                 Residual does not enter this outcome.
                  v(vp)=0.
               else
c                 Record the level l branch number.
                  if(l.eq.1)then
                     n=1
                  else
c                    The branch number must be unique even across level 2 branch
                     n=absbranch(l,branch,nbdim,nb)
                     n=n*(nb2+1)+ib2
                  endif
                  v(vp)=real(n)
c                 CAR(1) timevar must be at least one
                  if(mod(distype,10).eq.3.and.v(vp+nec).lt.1.)
     *               goto 840
               endif
               vp=vp+nec
c              The C/ARMA residual must enter either all or none of
c              the outcomes within the specified level.  Check this
c              for the second and higher subsequent outcomes within
c              the level l branch.  Note that "branch(l+1).gt.1" is
c              not a good test, because keep/drop statements may make
c              the first branch at level l+1 be beyond 1.  See, e.g.,
c              Trouble\trouble10, where l=2 and mdllvl=4.
               if(intvecequal(branch,prevbranch,l))then
c                 This is the 2+ time that level l branch is evaluated.
                  if(realisnan(v(vp-1)))then
                     if(.not.realisnan(v(vp)))goto 850
                  else
                     if(realisnan(v(vp)))goto 850
c                    Timevar must be strictly increasing within level,
c                    unless otherwise specified.
                     if(distyp(i).gt.0.and.v(vp).le.v(vp-1))goto 860
                  endif
               endif
               vp=vp+nec
  160       continue
            call copyint(branch,prevbranch,levelmax)
         endif
 
c        Go to next outcome:
         goto 120
  100 continue
      if(ie.ne.nec)call bug(ipt,jpt)
      goto 999
 
  830 string=idstring(struc(ib2),id,iobs,mdllvl(m),branch)
      if(modeltype(m).eq.6)then
         if(ipt.gt.0)call wrapstring(8,0,72,0,1,'ERROR:  there is no '//
     *      'residual in a continuous model ('//string(1:trm(string))//
     *      ').')
         if(jpt.gt.0)call wrapstring(6,0,72,0,1,'ERROR:  there is no '//
     *      'residual in a continuous model ('//string(1:trm(string))//
     *      ').')
      else
         if(ipt.gt.0)call wrapstring(8,0,72,0,1,'ERROR:  there is no '//
     *      'residual in a Tobit model ('//string(1:trm(string))//').')
         if(jpt.gt.0)call wrapstring(6,0,72,0,1,'ERROR:  there is no '//
     *      'residual in a Tobit model ('//string(1:trm(string))//').')
      endif
      stop
  840 name=distvar(i)
      string=idstring(struc(ib2),id,iobs,l+1,branch)
      vp=vp+nec
      if(ipt.gt.0)then
         call wrapstring(8,0,72,0,0,'ERROR:  CAR(1) processes start '//
     *      'at timevar=1.  The following time variable ('//
     *      string(1:trm(string))//') is thus illegitimate:  '//
     *      name(1:trm(name))//'=')
         call writedble(8,dble(v(vp)),0,-8,0,1)
      endif
      if(jpt.gt.0)then
         call wrapstring(6,0,72,0,0,'ERROR:  CAR(1) processes start '//
     *      'at timevar=1.  The following time variable ('//
     *      string(1:trm(string))//') is thus illegitimate:  '//
     *      name(1:trm(name))//'=')
         call writedble(6,dble(v(vp)),0,-8,0,1)
      endif
      stop
  850 name=distvar(i)
      string=idstring(struc(ib2),id,iobs,l+1,branch)
      if(ipt.gt.0)call writeaia(8,72,1,'ERROR:  you defined an ARMA '//
     *   'residual (with time variable '''//name(1:trm(name))//
     *   ''') which is autocorrelated within level ',l,
     *   '.  The residual must then either apply to all outcomes '//
     *   'within that level, or to none.  This is violated in a '//
     *   'continuous model ('//string(1:trm(string))//').')
      if(jpt.gt.0)call writeaia(6,72,1,'ERROR:  you defined an ARMA '//
     *   'residual (with time variable '''//name(1:trm(name))//
     *   ''') which is autocorrelated within level ',l,
     *   '.  The residual must then either apply to all outcomes '//
     *   'within that level, or to none.  This is violated in a '//
     *   'continuous model ('//string(1:trm(string))//').')
      stop
  860 name=distvar(i)
      string=idstring(struc(ib2),id,iobs,l+1,branch)
      vpntr6=vp-mod(vp-vpntr6,nec)
      if(ipt.gt.0)then
         call writeaia(8,72,1,'ERROR:  ARMA time variable '''//
     *      name(1:trm(name))//''' is not strictly increasing '//
     *      'within level ',l,' ('//string(1:trm(string))//'):')
         write(8,'(6x,8f6.1)')(v(i),i=vpntr6,vp)
         call writeaia(8,72,1,'NOTE:  this check may be turned off '//
     *      'in the ARMA distribution definition:   TIMEVAR (WITHIN '//
     *      'LEVEL ',l,') = '//name(1:trm(name))//';  INCREASING=NO;')
      endif
      if(jpt.gt.0)then
         call writeaia(6,72,1,'ERROR:  ARMA time variable '''//
     *      name(1:trm(name))//''' is not strictly increasing '//
     *      'within level ',l,' ('//string(1:trm(string))//'):')
         write(6,'(6x,8f6.1)')(v(i),i=vpntr6,vp)
         call writeaia(6,72,1,'NOTE:  this check may be turned off '//
     *      'in the ARMA distribution definition:   TIMEVAR (WITHIN '//
     *      'LEVEL ',l,') = '//name(1:trm(name))//';  INCREASING=NO;')
      endif
      stop
  999 return
      end
 
