      subroutine filtertobit(levelmax,mdllvl,nbdim,nb,branch,
     *   moel,meno,maxmeno,
     *   namepntr,nxold,nold,xpntr,xdim,maxxnode,x,xnode,outcome,
     *   lowerlimit,upperlimit,oldname,struc,iobs,id,ipt,jpt)
 
c     Subroutine to figure out whether a tobit outcome is probit
c     or continuous.  This routine is used in figure_model, figdata4,
c     and figdata6 to determine whether an outcome contributes a
c     probit or a continuous likelihood module.  Determine this on the
c     basis of outcome, lowerlimit, and upperlimit.
c
c     Constantijn Panis, 13 November 2002
 
      implicit none
      integer levelmax,mdllvl,nbdim,nb(nbdim,2),
     *   branch(levelmax),meno,maxmeno,
     *   moel(maxmeno),namepntr(levelmax),
     *   nxold(levelmax),nold,xpntr(2:levelmax),xdim,
     *   status,maxxnode,struc,iobs,id,ipt,jpt,trm
      real x(xdim),xnode(maxxnode),outcome,
     *   lowerlimit,upperlimit,realmax
      character oldname(*)*8,string*60,idstring*60
 
      lowerlimit=-realmax()
      upperlimit=realmax()
 
c     Outcome:
      call evalexpr(1,maxxnode,xdim,moel(meno),nold,levelmax,
     *   mdllvl,nbdim,nb,branch,xpntr,nxold,namepntr,xnode,x,
     *   outcome,oldname,struc,iobs,id,ipt,jpt,status)
      if(status.gt.0)stop
      meno=meno+1
      if(moel(meno).eq.1)then
c        Determine lower limit:
         call evalexpr(1,maxxnode,xdim,moel(meno+1),nold,levelmax,
     *      mdllvl,nbdim,nb,branch,xpntr,nxold,namepntr,xnode,x,
     *      lowerlimit,oldname,struc,iobs,id,ipt,jpt,status)
         if(status.gt.0)stop
         meno=meno+2
      endif
      if(moel(meno).eq.2)then
c        Determine upper limit:
         call evalexpr(1,maxxnode,xdim,moel(meno+1),nold,levelmax,
     *      mdllvl,nbdim,nb,branch,xpntr,nxold,namepntr,xnode,x,
     *      upperlimit,oldname,struc,iobs,id,ipt,jpt,status)
         if(status.gt.0)stop
         meno=meno+2
      endif
      if(lowerlimit.ge.upperlimit)goto 800
      goto 999
 
  800 string=idstring(struc,id,iobs,mdllvl,branch)
      meno=meno-4
      if(ipt.gt.0)then
         write(8,801)string(1:trm(string))
         call wrapstring(8,0,0,0,0,'lower limit = ')
         call writeexpr(111,8,maxxnode,xdim,levelmax,nbdim,
     *      -moel(meno+1),nb,branch,xpntr,1,nold,nxold,
     *      namepntr,-1,lowerlimit,xnode,x,oldname,struc)
         call wrapstring(8,0,0,0,0,'upper limit = ')
         call writeexpr(111,8,maxxnode,xdim,levelmax,nbdim,
     *      -moel(meno+3),nb,branch,xpntr,1,nold,nxold,
     *      namepntr,-1,upperlimit,xnode,x,oldname,struc)
      endif
      if(jpt.gt.0)then
         write(6,801)string(1:trm(string))
         call wrapstring(6,0,0,0,0,'lower limit = ')
         call writeexpr(111,6,maxxnode,xdim,levelmax,nbdim,
     *      -moel(meno+1),nb,branch,xpntr,1,nold,nxold,
     *      namepntr,-1,lowerlimit,xnode,x,oldname,struc)
         call wrapstring(6,0,0,0,0,'upper limit = ')
         call writeexpr(111,6,maxxnode,xdim,levelmax,nbdim,
     *      -moel(meno+3),nb,branch,xpntr,1,nold,nxold,
     *      namepntr,-1,upperlimit,xnode,x,oldname,struc)
      endif
  801 format(/,'ERROR: the lower limit of a double-censored tobit ',
     *   'model equals or',/,'exceeds the upper limit (',a,'):')
      stop
 
  999 return
      end
