      subroutine genposdef(b,k)
 
c     Subroutine to generate a full rank positive definite matrix,
c     for testing purposes.  Maximum dimension is b(kmax,kmax)
c
c     Note: requires extension drand(0)
c
c     Constantijn Panis,  7 December 1990
 
      implicit none
      integer k,kmax,round,i,j
      parameter(kmax=200)
      double precision v(kmax),b(k,k),drand
 
      call zerodp(k*k,b)
      do 100 round=1,2*k
         do 110 i=1,k
            v(i) = 2.d0*drand(0) - 1.d0
  110    continue
         do 120 i=1,k
            do 130 j=1,k
               b(i,j) = b(i,j) + v(i)*v(j)
  130       continue
  120    continue
  100 continue
 
      return
      end
