      subroutine getints(unit,intvector,maxdim,dim,line,begin,status)
 
c     Function to read up to maxdim next integers on 'line'. The scan
c     starts at position line(begin:begin).  The integers must be followed
c     by a semicolon.  The number of integers read in is given by dim.
c     If there were more than maxdim integers before the semicolon, the
c     error return is used and dim is set to the number of integers before
c     the semicolon, even though only the first maxdim are placed in
c     intvector.
c
c     Upon successful output, begin is updated to point at the position
c     just after the semicolon.
c     If a non-integer is encountered the error return is used and
c     begin will indicate the beginning position of the non-integer.
c
c     This routine is similar to next_ints, except that the next line
c     on unit=unit will be read if the end (position 80) of the line
c     has been reached.
c
c     Constantijn Panis, 23 March 2001
c     Last change: status instead of alternate return
 
      implicit none
      integer unit,maxdim,intvector(maxdim),dim,begin,status,n
      character line*(*)
      logical smtxt
 
      status=0
      dim=0
  100 if(smtxt(unit,line,begin,';'))goto 999
      dim=dim+1
      if(dim.gt.maxdim)goto 200
      call getint(unit,intvector(dim),line,begin,status)
      if(status.gt.0)goto 800
      if(dim.le.maxdim)goto 100
 
c     Maxdim is exceeded; count number of integers, but don't keep them
  200 if(smtxt(unit,line,begin,';'))goto 800
      call getint(unit,n,line,begin,status)
      if(status.gt.0)goto 800
      dim=dim+1
      goto 200
 
  800 status=1
  999 return
      end
