      subroutine getreal(unit,realvar,line,begin,status)
 
c     Function to read the next real number on 'line'.
c     The scan starts at position line(begin:begin).
c     Upon return, begin is updated to be the position immediately
c     following the word.
c
c     If the next word is not a number, the error return is used.
c     Integer variable begin will then not be updated.
c
c     This routine is similar to next_real, except that the next line
c     on unit=unit will be read if the end (position 80) of the line
c     has been reached.
c
c     Constantijn Panis, 23 March 2001
c     Last change: status instead of alternate return
 
      implicit none
      real realvar
      integer unit,begin,il,i1,i2,itemp,status
      character line*(*)
 
      status=0
      il=begin
      call getword(unit,line,il,i1,i2,status)
      if(status.gt.0)goto 810
      if(line(i1:i2).eq.'-'.or.line(i1:i2).eq.'+')then
         call getword(unit,line,il,itemp,i2,status)
         if(status.gt.0)goto 800
      endif
      if((line(i2:i2).eq.'e'.or.line(i2:i2).eq.'E').and.
     *   (line(i2+1:i2+1).eq.'-'.or.line(i2+1:i2+1).eq.'+'))then
         il=il+1
         call getword(unit,line,il,itemp,i2,status)
         if(status.gt.0)goto 800
      endif
 
      call c2real(line(i1:i2),realvar,status)
      if(status.ne.0)goto 800
      begin=il
      goto 999
 
c     Next word is not a number; error return without update of begin:
  800 status=1
      goto 999
c     Rest of line is empty; error return with update of begin:
  810 begin=il
      status=0
      goto 999
  999 return
      end
