      subroutine gotochar(unit,char,line,il,status)
 
c     Subroutine to place il at position in line immediately following
c     character char.  If position 80 is exceeded, read new line from
c     unit unit, except when unit=0.
c
c     If line(80:80)=char:
c        if unit!=0, the next line is read and il is set to zero.  (If the
c        end of file is encountered, line is ' '.)
c        if unit=0, il is set to 81.
c     In both cases, status=0.  Status=1 only in case char is never encountered.
c
c     If a ' or " is encountered, indicating the beginning of a string,
c     any char inside that string is ignored.  However, if char is a
c     ' or ", encountering such character makes this routine return.
c
c     Constantijn Panis, 23 March 2001
c     Last change: status instead of alternate return
 
      implicit none
      integer unit,il,status,i,string
      character line*128,char*1,sq*1,dq*1
 
      status=0
 
c     Single and double quotes (ASCII characters 39 and 34):
      sq=''''
      dq='"'
      string=0
c     Note the coding of string:
c        string = 0 not inside a string
c                 1 inside a single-quoted string
c                 2 inside a double-quoted string
c        Note: can never be inside both types of string
 
  100 do 110 i=il,80
         if(string.eq.0)then
            if(line(i:i).eq.char)goto 200
c           Does current character open a string?
            if(line(i:i).eq.sq)then
               string=1
            elseif(line(i:i).eq.dq)then
               string=2
            endif
         elseif(string.eq.1)then
c           Does current character close the single-quote string?
            if(line(i:i).eq.sq)string=0
         elseif(string.eq.2)then
c           Does current character close the double-quote string?
            if(line(i:i).eq.dq)string=0
         endif
  110 continue
      if(unit.eq.0)goto 800
      read(unit,'(a80)',end=800,err=800)line
      il=1
      goto 100
 
c     line(i:i) equals char
  200 if(i.eq.80)then
         if(unit.eq.0)then
            il=81
         else
            line=' '
            il=1
c           OK if end of file is encountered.
            read(unit,'(a80)',end=999,err=800)line
         endif
      else
         il=i+1
      endif
      goto 999
 
  800 status=1
  999 return
      end
