      character*8 function ifmt(i,skip,lf)
 
c     Character function that returns the "best" format to write out
c     an integer.  Arguments:
c        i    [in] integer number to be written
c        skip [in] number of spaces to be skipped before writing i.
c                  If skip<0, an additional space is skipped if x>0 and n>0
c                  (to accommodate the minus sign in neighboring numbers).
c                  Since -0 cannot be distinguished from 0, special
c                  value -100 is used instead.
c        lf   [in] integer controlling whether a linefeed is written after
c                  the number:  0=no;  other=yes.
c
c     Example:
c        integer i
c        character ifmt*8
c        write(8,ifmt(i,-2,0))i
c
c     Constantijn Panis, 5 May 1996
 
      implicit none
      integer i,skip,lf,n,ss,intlen,trm
      character i2c*12,nc*3
 
      ss=abs(skip)
      if(skip.eq.-100)ss=0
 
c     Number of spaces required for i:
      n=intlen(i)
c     Additional leading blanks:
      n=n+ss
c     Additional space if skip<0 and i>=0:
      if(skip.lt.0.and.i.ge.0)n=n+1
 
      nc=i2c(n,0)
 
      if(lf.eq.0)then
c        Linefeed is suppressed; format is something like '(i8,$)'
         ifmt='(i'//nc(1:trm(nc))//',$)'
      else
c        Linefeed is written; format is something like '(i8)'
         ifmt='(i'//nc(1:trm(nc))//')'
      endif
 
      return
      end
