      integer function introwmax(a,nrow,ncol)
 
c     Function to determine the maximum of row elements of
c     matrix a.  The maximum of the first row is computed; should
c     the maximum of row i be desired, use the routine as follows:
c        introwmax(a(i,1),nrow,ncol)
c
c     If ncol<=0 or nrow<=0, introwmax=0 is returned.
c
c     Note the existence of intvecmax, which determines the maximum
c     element of a vector.
c
c     Constantijn Panis,  3 January 2000
 
      implicit none
      integer nrow,ncol,a(nrow*ncol),i,temp
 
      if(ncol.le.0.or.nrow.le.0)then
         introwmax=0
      else
         temp=a(1)
         do 100 i=1+nrow,nrow*ncol,nrow
            temp = max(temp,a(i))
  100    continue
         introwmax=temp
      endif
 
      return
      end
