      integer function lamtypdim(numrow,numcol,lamtyp)
 
c     Integer function to determine the dimension of a load matrix
c     Lambda.  Its dimension is:
c        lamtyp = -1:  Lambda is not used  lamdim = 0
c        lamtyp =  0:  Lambda is generic   lamdim = numrow*numcol
c        lamtyp =  1:  Lambda is identity  lamdim = 0
c        lamtyp =  4:  Lambda is sparse    lamdim = 2*numrow
c
c     Constantijn Panis, 27 November 2001
 
      implicit none
      integer numrow,numcol,lamtyp
 
      if(lamtyp.eq.-1)then
         lamtypdim=0
      elseif(lamtyp.eq.0)then
         lamtypdim=numrow*numcol
      elseif(lamtyp.eq.1)then
         lamtypdim=0
      elseif(lamtyp.eq.4)then
         lamtypdim=2*numrow
      else
         call bug(0,1)
      endif
 
      return
      end
