      double precision function logdnorm1(x)
 
c     Function to compute the log of the standard normal density:
c
c     density = (2*pi)**-.5 * exp(-.5*x*x)
c     log-density = -.5*log(2*pi) - .5*x*x
c
c     Note that this function is the log of function dnorm1.
c     Constantijn Panis,  15 december 1990
c     Change April 2, 1996: log2pi was used, which really was log2pi/2
 
      implicit none
      double precision halflog2pi,x
      parameter(halflog2pi=.9189385332046727417803296d0)
 
      logdnorm1 = -halflog2pi-.5d0*x*x
 
      return
      end
