      subroutine mdytoe(month,day,year,edate)
 
c     Subroutine to convert a numerical day/month/year date into an
c     elapsed date (days since 1/1/1960).
c
c     month   [in] month of the year (integer)
c     day     [in] day of the month (integer)
c     year    [in] year (integer; 4 digits)
c     edate  [out] elapsed date (integer; days since 1/1/1960)
c
c     Bug: dates like 30 Feb do not result in a error message, but
c          are interpreted as 1 or 2 March, depending on whether it
c          is a leap year.
c
c     Note the existence of etomdy, which maps the inverse.
c
c     This routine is based on Stata-provided mdytoe.ado.
c
c     Constantijn Panis, 8 November 1999
 
      implicit none
      integer day,month,year,edate,temp
 
      temp = (month-14)/12
      edate = day - 2469010 + 1461*(year+4800+temp)/4 +
     *   367*(month-2-temp*12)/12 - 3*((year+4900+temp)/100)/4
 
      return
      end
 
