      double precision function minexp()
 
c     Double precision function to return the smallest number
c     that does not result in an underflow when e is raised to
c     its power, i.e., the smallest x s.t. exp(x)>0
c
c     WARNING: this routine is machine specific!
c     For a Sun-4, minexp() = -745.13321910194d0
c     For MS Fortran Powerstation minexp() = -708.396418532264100
c
c     Note:  MS Fortran Powerstation has a bug in optimized form.
c     For example:
c           double precision x
c           x = dlog(tiny(x))
c           write(*,*)(x.eq.dlog(tiny(x)))
c
c     writes F for False.  The debug version does not do this.
c     Instead of minexp() = dlog(tiny(minexp()) we therefore hardwire.
c
c     Not sure what Digital Fortran does; follow Microsoft.
c
c     Constantijn Panis, 17 April 2001
c     Made compatible with GNU f77.
 
      implicit none
 
      minexp = 'c0874910d52d3051'X
cD     minexp = dlog(tiny(minexp))
c     minexp = -708.396418532264100
 
      return
      end
