      subroutine prep5b(task,nfullplus,nmapmoel,neb,dimp,numdist,
     *   dimlam,distdim,lamtyp,lampos,dimv,mapmoel,moelpos,
     *   rsnpmax,fullbeta,dfullbeta,p5,dp5,lam,dlam,lnlobs,v,vpntr,
     *   ipt,jpt)
 
c     Subroutine to prepare and unravel binomial modules in ithobs.
c     Task=1: compute probability location, set up lam for
c             probability integrated residual.  Compute log of product
c             over outcomes of exposure-choose-outcome.
c     Task 2: unravel everything into wrt fullbeta.
c
c     Constantijn Panis, 11 November 2002
c     Last change: dimension p5 includes Poisson: dimp=neb+nen+nepo
 
      implicit none
      integer task,nfullplus,nmapmoel,neb,dimp,numdist,dimlam,
     *   distdim(numdist),lamtyp(numdist),lampos(numdist),dimv,
     *   mapmoel(nmapmoel),rsnpmax,ipt,jpt,moelpos,vpntr,ie,
     *   n,y,vpntr5
      double precision fullbeta(nfullplus),dfullbeta(nfullplus),
     *   p5(dimp,0:rsnpmax),dp5(dimp),
     *   lam(dimlam),dlam(dimlam),lnlobs,lnnbym
      real v(dimv)
 
      vpntr5=vpntr-1
c     The first positions in v are for:
c        neb binomial count outcomes
c        neb binomial probability transformation types
c        neb binomial exposure values
      vpntr=vpntr+3*neb
 
      if(task.eq.2)goto 200
 
c     Compute the logarithm of the number of combinations (exposure-choose-count
c     and set up regressor sets and load matrices for the probability.
  100 do 110 ie=1,neb
         if(v(vpntr).ne.real(ie))call bug(ipt,jpt)
         vpntr=vpntr+1
c        Compute p5 (probability location) and the load matrix on
c        integrated residuals.
         call prepfunc(1,ie,dimp,neb,nmapmoel,dimv,mapmoel,moelpos,
     *      vpntr,nfullplus,rsnpmax,numdist,distdim,dimlam,lamtyp,
     *      lampos,fullbeta,dfullbeta,p5,dp5,lam,dlam,0.d0,v,ipt,jpt)
 
c        Log of exposure-choose-count (n-choose-y):
         n=int(v(vpntr5+ie+2*neb))
         y=int(v(vpntr5+ie))
c        Save computations in some common cases:
         if(y.eq.0.or.y.eq.n)then
c           n-choose-y=1
            continue
         elseif(y.eq.1.or.y.eq.n-1)then
c           n-choose-y=n
            lnlobs=lnlobs+dlog(dble(n))
         else
c           General formula:
            lnlobs=lnlobs+lnnbym(n,y)
         endif
 
  110 continue
      goto 999
 
c     Unravel everything into wrt fullbeta.
  200 do 210 ie=1,neb
         if(v(vpntr).ne.real(ie))call bug(ipt,jpt)
         vpntr=vpntr+1
c        Unravel wrt the probability location and the load
c        matrix for integrated residuals in the probability:
         call prepfunc(2,ie,dimp,neb,nmapmoel,dimv,mapmoel,moelpos,
     *      vpntr,nfullplus,rsnpmax,numdist,distdim,dimlam,lamtyp,
     *      lampos,fullbeta,dfullbeta,p5,dp5,lam,dlam,
     *      0.d0,v,ipt,jpt)
  210 continue
      goto 999
 
  999 return
      end
 
