      subroutine prepchol(nfree,freetype,ipt,jpt,dimalld,alld,
     *   freebeta,freename)
 
c     Subroutine to compute Cholesky decompositions of covariance
c     matrices that are estimated based on such decompositions.
c
c     Constantijn Panis, 1 February 2000
c     Last change: no bug if cholesky matrix is not last block
 
      implicit none
      integer nfree,freetype(nfree),ipt,jpt,dimalld,i,match,dim,pos,
     *   status,trm
      double precision alld(dimalld),freebeta(nfree)
      character freename(nfree)*8
 
      pos=1
      i=1
  100 call intmatch(5,freetype(i),nfree-i+1,match)
      if(match.eq.0)goto 999
      match=match+i-1
      dim=0
  110 dim=dim+1
      if(freetype(match+dim).eq.5)goto 110
c     Compute the decomposition:
      if(pos+dim*(dim+1)/2-1.gt.dimalld)call bug(ipt,jpt)
      call corr2chol(dim,freebeta(match),alld(pos),status)
      if(status.ne.0)goto 800
      pos=pos+dim*dim
      i=match+(dim*(dim+1))/2
      if(i.ge.nfree)goto 999
      goto 100
 
  800 i=match+(dim*(dim+1))/2-1
      if(ipt.gt.0)write(8,801)freename(match)
     *  (1:trm(freename(match))),freename(i)(1:trm(freename(i)))
      if(jpt.gt.0)write(6,801)freename(match)
     *  (1:trm(freename(match))),freename(i)(1:trm(freename(i)))
  801 format(/,'ERROR: the covariance matrix formed by ''',a,
     *   '''',/,'through ''',a,''' is not positive definite.')
      stop
  999 return
      end
