      subroutine prepinv(task,nfull,nfullplus,fullbeta,dfullbeta,
     *   numpar,pardim,parpos,parname,ipt,jpt)
 
c     Subroutine to compute the inverse of matrices of which inverse
c     elements are ever used, and to unravel derivatives.
c
c     Constantijn Panis, 27 April 1997
 
      implicit none
      integer task,nfull,nfullplus,numpar,pardim(numpar),parpos(numpar),
     *   ipt,jpt,status,dim1,dim2,pos,i,trm
      double precision fullbeta(nfullplus),dfullbeta(nfullplus),
     *   sign,lndet,lneps
      character parname(numpar)*12
      parameter(lneps=-10.d0)
 
      pos=nfull+1
      if(task.eq.2)goto 200
 
      do 100 i=1,numpar
         if(pardim(i).lt.0)then
c           Matrix whose inverse elements are never referenced.
c           Read_par did assume, however, that fullbeta contains
c           space for its inverse.
            dim1 = abs(pardim(i))/nfull
            dim2 = mod(abs(pardim(i)),nfull)
         elseif(pardim(i).le.nfull)then
c           Regular parameter or vector.
            goto 100
         else
c           Matrix whose inverse elements are referenced.
            dim1 = pardim(i)/nfull
            dim2 = mod(pardim(i),nfull)
            if(dim1.ne.dim2)call bug(ipt,jpt)
c           Note: nrminv will destroy the original matrix.  Use
c           dfullbeta as scratch array.
            call copy8(fullbeta(parpos(i)),dfullbeta,dim1*dim2)
            status=0
            call nrminv(2,dfullbeta,fullbeta(pos),dim1,sign,lndet,
     *         status)
            if(status.gt.0.or.sign.eq.0.d0)goto 800
            if(lndet.lt.lneps)then
               if(ipt.ge.3)write(8,101)parname(i)(1:trm(parname(i))),
     *            sign*dexp(lndet)
               if(jpt.ge.3)write(6,101)parname(i)(1:trm(parname(i))),
     *            sign*dexp(lndet)
  101          format(/,'WARNING:  the determinant of matrix ''',a,
     *           ''' is',1pe12.4,', i.e., the',/,'matrix is very ',
     *           'close to singular.  Your model may be ',
     *           'underidentified.')
            endif
         endif
         pos = pos+dim1*dim2
  100 continue
      goto 999
 
c     Unravel derivatives:
  200 do 210 i=1,numpar
         if(pardim(i).lt.0)then
c           Matrix whose inverse elements are never referenced.
c           Read_par did assume, however, that fullbeta contains
c           space for its inverse.
            dim1 = abs(pardim(i))/nfull
            dim2 = mod(abs(pardim(i)),nfull)
         elseif(pardim(i).le.nfull)then
c           Regular parameter or vector.
            goto 210
         else
c           Matrix whose inverse elements are referenced.
            dim1 = pardim(i)/nfull
            dim2 = mod(pardim(i),nfull)
            if(dim1.ne.dim2)call bug(ipt,jpt)
c           Note that    dA = -(Ai)'*dAi*(Ai)'
            call dminv2dm(dfullbeta(pos),dfullbeta(parpos(i)),
     *         dim1,fullbeta(pos),.true.)
         endif
         pos = pos+dim1*dim2
  210 continue
      goto 999
 
  800 if(ipt.gt.0)write(8,801)parname(i)(1:trm(parname(i)))
      if(jpt.gt.0)write(6,801)parname(i)(1:trm(parname(i)))
  801 format(/,'ERROR:  matrix ''',a,''' is singular and cannot be ',
     *   'inverted.')
      stop
  999 return
      end
