      subroutine read_tauvars(levelmax,nxold,namepntr,nold,mdllvl,
     *   numfreq,maxnumfreq,freqloc,xnodepos,maxxnode,xnode,il,struc,
     *   oldname,line,ipt,jpt)
 
c     Subroutine to read THRESHOLD VARiable specifications in
c     ordered logit/probit models.  The syntax is:
c
c        THRESHOLD VARS = varname(-inf=x) varname(inf=x);
c
c     where both varname and x may be expressions.  The lowest level
c     of either variable name determines the outcome level.
c
c     Constantijn Panis,  6 April 1998
 
      implicit none
      integer levelmax,nxold(levelmax),namepntr(levelmax),
     *   nold,mdllvl,numfreq,maxnumfreq,freqloc(maxnumfreq),xnodepos,
     *   maxxnode,il,struc,ipt,jpt,level,level1,level2
      real xnode(maxxnode),endexpr
      character oldname(*)*8,line*128
 
      call readexpr(1,levelmax,levelmax,level1,1,nold,maxxnode,
     *   xnodepos,xnode,nxold,namepntr,0,0,0,
     *   oldname,line,il,ipt,jpt,struc,'(-INF=')
c     Change end-of-expressions into end-of-expression
      xnode(xnodepos)=endexpr()
      call readexpr(1,levelmax,level1,level,1,nold,maxxnode,
     *   xnodepos,xnode,nxold,namepntr,numfreq,maxnumfreq,freqloc,
     *   oldname,line,il,ipt,jpt,struc,')')
c     Change end-of-expressions into end-of-expression
      xnode(xnodepos)=endexpr()
      call readexpr(1,levelmax,levelmax,level2,1,nold,maxxnode,
     *   xnodepos,xnode,nxold,namepntr,0,0,0,
     *   oldname,line,il,ipt,jpt,struc,'(INF=')
c     Change end-of-expressions into end-of-expression
      xnode(xnodepos)=endexpr()
      call readexpr(1,levelmax,level2,level,1,nold,maxxnode,
     *   xnodepos,xnode,nxold,namepntr,numfreq,maxnumfreq,freqloc,
     *   oldname,line,il,ipt,jpt,struc,');')
      mdllvl=max(level1,level2)
 
  999 return
      end
