      subroutine spltx(x,v,nodes,numnodes,funcform,ipt,jpt)
 
c     Subroutine to compute the spline vector transformation of a variable
c     and to interact this vector with the value in v(1)-v(numnodes+1).
c
c     The name is short for "spline-transformation-interact".
c
c     Constantijn Panis, 7 July 1996
 
      implicit none
      integer numnodes,funcform,ipt,jpt,i
      real nodes(numnodes),x,v(0:numnodes),
     *   nodelow,nodehigh,temp,temp1,temp2,node1
 
      if(numnodes.eq.0)then
         call interact(v(0),x,funcform,1,ipt,jpt)
      elseif(nodes(1).lt.0.)then
c        First node negative:
c           beta'T(x) = beta'T*(x-node1) - beta'T*(0-node1)
c        where T*(x) is the spline transformation of x with
c        nodes relative to node1.
         node1=nodes(1)
         nodehigh=0.
         temp1=min(x-node1,nodehigh)
         temp2=min(-node1,nodehigh)
         call interact(v(0),temp1-temp2,funcform,1,ipt,jpt)
         nodelow=nodehigh
         do 100 i=2,numnodes
            nodehigh=nodes(i)-node1
            if(nodehigh.lt.nodelow)goto 800
            temp1=max(0.,min(x-node1-nodelow,nodehigh-nodelow))
            temp2=max(0.,min(-node1-nodelow,nodehigh-nodelow))
            call interact(v(i-1),temp1-temp2,funcform,1,ipt,jpt)
            nodelow=nodehigh
  100    continue
         temp1=max(0.,x-node1-nodelow)
         temp2=max(0.,-node1-nodelow)
         call interact(v(numnodes),temp1-temp2,funcform,1,ipt,jpt)
      else
c        First node positive
         nodehigh=nodes(1)
         temp=min(x,nodehigh)
         call interact(v(0),temp,funcform,1,ipt,jpt)
         nodelow=nodehigh
         do 200 i=2,numnodes
            nodehigh=nodes(i)
            if(nodehigh.lt.nodelow)goto 800
            temp=max(0.,min(x-nodelow,nodehigh-nodelow))
            call interact(v(i-1),temp,funcform,1,ipt,jpt)
            nodelow=nodehigh
  200    continue
         temp=max(0.,x-nodelow)
         call interact(v(numnodes),temp,funcform,1,ipt,jpt)
      endif
      goto 999
 
  800 if(ipt.gt.0)write(8,801)
      if(jpt.gt.0)write(6,801)
  801 format(/,'ERROR: unordered spline nodes:')
      do 810 i=1,numnodes
         if(ipt.gt.0)call writedble(8,dble(nodes(i)),2,-8,0,i/numnodes)
         if(jpt.gt.0)call writedble(6,dble(nodes(i)),2,-8,0,i/numnodes)
  810 continue
      stop
  999 return
      end
