      integer function sq2cmp(i,j,dim)
 
c     Covariance matrices with dimension (dim,dim) are often stored in
c     compressed format in dimension dim*(dim+1)/2:
c        var(1)
c        var(2)
c          :
c        var(dim)
c        cov(2,1)
c        cov(3,1)
c          :
c        cov(dim,1)
c        cov(3,2)
c          :
c        cov(dim,2)
c          :
c          :
c
c     This function returns the position in the compressed vector of
c     cov(i,j).
c
c     Constantijn Panis, 15 January 1994
 
      implicit none
      integer i,j,dim
 
      if(i.eq.j)then
c        Variance element:
         sq2cmp=i
      elseif(i.gt.j)then
c        Covariance element in lower triangle:
         sq2cmp=j*dim-(j*(j+1))/2+i
      else
c        Covariance element in upper triangle:
         sq2cmp=i*dim-(i*(i+1))/2+j
      endif
 
      return
      end
