      subroutine wr_d_par(nfull,numpar,maxref,parref,parpos,pardim,
     *   parname,fullname,fulltype,unit,ipt,jpt)
 
c     Subroutine to write out parameter and vector definitions.
c     Reference numbers are in a long vector, not rectangular.
c
c     Constantijn Panis, 1 February 2000
c     Last change: other style
 
      implicit none
      integer nfull,numpar,maxref,parref(maxref),parpos(numpar),ipt,jpt,
     *   pardim(numpar),fulltype(nfull),refpos,
     *   nt1,nt2,i,num,unit,dim,dim1,dim2,trm
      character parname(numpar)*12,fullname(*)*8
 
      if(numpar.eq.0)goto 999
      refpos=1
      write(unit,101)
  101 format(/,'The following parameters, vectors, and matrices have ',
     *   'been defined:')
 
      do 100 i=1,numpar
         dim=abs(pardim(i))
         call intmatch(0,parref(refpos),maxref-refpos+1,num)
         if(num.eq.0)call bug(ipt,jpt)
         num=num-1
 
         nt1=trm(fullname(parpos(i)))
         if(dim.eq.1)then
c           Parameter
            if(parname(i).eq.'(unnamed)')then
               write(unit,102)fullname(parpos(i))(1:nt1)
  102          format(/,'define parameter;  /* coefficient name: ',
     *            a,' */')
            else
               write(unit,103)parname(i)(1:trm(parname(i))),
     *            fullname(parpos(i))(1:nt1)
  103          format(/,'define parameter ',a,
     *            ';  /* coefficient name: ',a,' */')
            endif
            if(num.gt.0)call writerefs(unit,num,parref(refpos))
            if(fulltype(parpos(i)).eq.1)write(unit,104)'(0,+Inf)'
            if(fulltype(parpos(i)).eq.2)write(unit,104)'(-1,1)'
            if(fulltype(parpos(i)).eq.3)write(unit,104)'(0,1)'
  104       format(3x,'range=',a,';')
         elseif(dim.le.nfull)then
c           Vector
            nt2=trm(fullname(parpos(i)+dim-1))
            if(parname(i).eq.'(unnamed)')then
               write(unit,112)fullname(parpos(i))(1:nt1),
     *            fullname(parpos(i)+dim-1)(1:nt2)
  112          format(/,'define vector;  /* coefficient names: ',
     *            a,' - ',a,' */')
            else
               write(unit,113)parname(i)(1:trm(parname(i))),
     *            fullname(parpos(i))(1:nt1),
     *            fullname(parpos(i)+dim-1)(1:nt2)
  113          format(/,'define vector ',a,';  /* coefficient names: ',
     *            a,' - ',a,' */')
            endif
            if(num.gt.0)call writerefs(unit,num,parref(refpos))
            call writeaia(unit,72,1,'   dim=',dim,';')
            if(fulltype(parpos(i)+1).eq.4)then
               write(unit,'(3x,a)')'increasing;'
            else
               write(unit,'(3x,a)')'increasing=no;'
            endif
            if(fulltype(parpos(i)).eq.1)write(unit,104)'(0,+Inf)'
            if(fulltype(parpos(i)).eq.2)write(unit,104)'(-1,1)'
            if(fulltype(parpos(i)).eq.3)write(unit,104)'(0,1)'
            nt1=trm(fullname(parpos(i)))
            nt2=trm(fullname(parpos(i)+dim-1))
         else
c           Matrix
            dim1=dim/nfull
            dim2=mod(dim,nfull)
            dim=dim1*dim2
            nt2=trm(fullname(parpos(i)+dim-1))
            write(unit,123)parname(i)(1:trm(parname(i))),
     *         fullname(parpos(i))(1:nt1),
     *         fullname(parpos(i)+dim-1)(1:nt2)
  123       format(/,'define matrix ',a,';  /* coefficient names: ',
     *         a,' - ',a,' */')
            call writea2ia(unit,72,1,'   dim=(',dim1,',',dim2,');')
         endif
         refpos=refpos+num+1
  100 continue
 
  999 return
      end
