      subroutine write_model(levelmax,nfull,nummodel,numdist,sumdim,
     *   numrset,numspl,numpar,dimmax,datadim,maxref,mdllvl,distpos,
     *   distdim,distyp,distrestrpos,distrestr,resref,intpnts,
     *   rsetref,rsetbegin,rsetnum,maxxnode,
     *   parref,parpos,pardim,fulltype,splref,beginspl,nodepos,
     *   numnodes,spltype,datas,strctre,moel,
     *   moelpntr,modeltype,minlnl,namepntr,nold,
     *   maxnumfreq,maxfreqcat,nfreq,freqloc,freqcat,freqs,
     *   originstats,rsetstats,xnode,detail,oldname,fullname,
     *   corrname,rsetname,splname,distvar,resname,
     *   parname,ipt,jpt,version,prof)
 
c     Subroutine to write out definitions and model specifications.
c
c     Constantijn Panis, 4 April 2003
c     Last change: initialize status
 
      implicit none
      integer levelmax,unit,nfull,nummodel,numdist,sumdim,numrset,
     *   numspl,numpar,dimmax,maxref,mdllvl(nummodel),distpos(numdist),
     *   distdim(numdist),
     *   distyp(numdist),distrestrpos(numdist),distrestr(0:*),
     *   resref(maxref),intpnts(sumdim),rsetref(maxref),
     *   rsetbegin(numrset),rsetnum(numrset),
     *   maxxnode,parref(maxref),parpos(numpar),pardim(numpar),
     *   fulltype(*),splref(maxref),beginspl(numspl),nodepos(numspl),
     *   datadim,numnodes(numspl),spltype(numspl),datas(nummodel),
     *   strctre(nummodel),moel(*),
     *   moelpntr(nummodel),modeltype(nummodel),minlnl(nummodel),
     *   namepntr(levelmax,datadim),nold,
     *   maxnumfreq,maxfreqcat,nfreq(nummodel),
     *   freqloc(maxnumfreq),freqs(maxfreqcat,maxnumfreq),ipt,jpt,
     *   version,prof,status,meno,ds,m,select,num,pos,countint,intvecsum
      double precision originstats(5,numspl),rsetstats(5,nfull)
      real xnode(maxxnode),freqcat(maxfreqcat,maxnumfreq)
      logical detail
      character oldname(*)*8,fullname(nfull)*8,
     *   corrname(dimmax,dimmax)*8,rsetname(numrset)*12,
     *   splname(numspl)*12,distvar(numdist)*8,
     *   resname(sumdim)*12,parname(numpar)*12
 
      status=0
 
c     First compute statistics on spline origins and regressor set elements:
      if(detail)then
         call compstats(numspl,originstats)
         call compstats(nfull,rsetstats)
      endif
 
      if(ipt.lt.4)goto 200
      unit=8
 
c     Write out parameter, vector, and matrix definitions:
  100 call wr_d_par(nfull,numpar,maxref,parref,parpos,pardim,
     *   parname,fullname,fulltype,unit,ipt,jpt)
 
c     Write out regressor set definitions:
      call wr_d_rset(numrset,maxref,nfull,nold,maxxnode,rsetref,
     *   rsetbegin,rsetnum,rsetstats,xnode,rsetname,oldname,fullname,
     *   detail,unit)
 
c     Write out spline definitions:
      call wr_d_spl(numspl,maxref,splref,beginspl,numnodes,
     *   nodepos,spltype,maxxnode,unit,originstats,xnode,detail,
     *   splname,fullname,ipt,jpt)
 
c     Write out distribution definitions:
      call wr_d_dist(unit,numdist,sumdim,dimmax,maxref,distpos,
     *   distdim,distyp,distrestrpos,distrestr,fulltype,resref,intpnts,
     *   distvar,fullname,resname,parname,corrname,ipt,jpt)
 
c     Write out model specifications:
      write(unit,'(//,a)')'The following models have been specified:'
      do 110 m=1,nummodel
c        Which rank number data structure is this model?
         ds=strctre(m)
c        Where in moel does the model specification begin?
         select=moel(moelpntr(m))
         meno=moelpntr(m)+1
 
         write(unit,'(1x)')
         if(modeltype(m).eq.1)then
            write(unit,'(a)')'hazard model;'
         elseif(modeltype(m).eq.41)then
            write(unit,'(a)')'logit model;'
         elseif(modeltype(m).eq.42)then
            write(unit,'(a)')'ordered logit model;'
         elseif(modeltype(m).eq.43)then
            write(unit,'(a)')'probit model;'
         elseif(modeltype(m).eq.44)then
            write(unit,'(a)')'ordered probit model;'
         elseif(modeltype(m).eq.46)then
            write(unit,'(a)')'tobit model;'
         elseif(modeltype(m).eq.6)then
            write(unit,'(a)')'continuous model;'
         elseif(modeltype(m).ge.51.and.modeltype(m).le.53)then
            write(unit,'(a)')'binomial model;'
         elseif(modeltype(m).ge.54.and.modeltype(m).le.56)then
            write(unit,'(a)')'negative binomial model;'
         elseif(modeltype(m).eq.57)then
            write(unit,'(a)')'negative binomial model;'
         elseif(modeltype(m).eq.58)then
            write(unit,'(a)')'Poisson model;'
         elseif(modeltype(m).eq.71)then
            write(unit,'(a)')'multinomial logit model;'
         elseif(modeltype(m).eq.72)then
            write(unit,'(a)')'multinomial probit model;'
         else
            call bug(1,1)
         endif
         if(datas(m).ne.0)call writeaia(unit,72,1,
     *      '   data structure = ',datas(m),';')
 
c        Write out drop or keep statement, if any:
         if(select.ne.0)then
            if(select.lt.0)call wrapstring(unit,0,0,1,0,'   drop if ')
            if(select.gt.0)call wrapstring(unit,0,0,1,0,'   keep if ')
            call writeexpr(100,unit,maxxnode,0,levelmax,1,-abs(select),
     *         0,0,0,0,nold,0,namepntr(1,ds),-1,0.,xnode,0.,oldname,0)
            write(unit,'(a)')';'
         endif
 
         if(minlnl(m).eq.1)then
            write(unit,'(3x,a)')'denominator;'
         elseif(minlnl(m).eq.2)then
            write(unit,'(3x,a)')'numerator;  denominator;'
         endif
 
         if(modeltype(m).eq.1)then
c           Hazard model:
            call wrmodel1(levelmax,unit,mdllvl(m),nfull,numdist,sumdim,
     *         numpar,meno,moel,maxxnode,distdim,pardim,parpos,
     *         namepntr(1,ds),nold,xnode,oldname,
     *         parname,rsetname,resname,splname)
         elseif(modeltype(m).eq.46)then
c           Tobit model:
            call wrmodel46(levelmax,unit,nfull,numdist,sumdim,
     *         numpar,meno,moel,distdim,pardim,parpos,
     *         namepntr(1,ds),nold,maxxnode,xnode,oldname,parname,
     *         rsetname,resname,splname)
         elseif(modeltype(m)/10.eq.4)then
c           Logit/probit model:
            call wrmodel4(levelmax,unit,nfull,numdist,sumdim,
     *         numpar,meno,moel,distdim,pardim,parpos,
     *         namepntr(1,ds),nold,maxxnode,xnode,oldname,parname,
     *         rsetname,resname,splname)
         elseif(modeltype(m)/10.eq.7)then
c           Multinomial logit/probit model:
            call wrmodel7(modeltype(m),levelmax,unit,nfull,numdist,
     *         sumdim,numpar,meno,moel,maxxnode,distdim,pardim,parpos,
     *         namepntr(1,ds),nold,xnode,oldname,parname,rsetname,
     *         resname,splname,nfreq(m),maxfreqcat,maxnumfreq,
     *         freqs,freqcat,prof,status)
         elseif(modeltype(m).eq.6)then
c           Continuous model:
            call wrmodel6(levelmax,unit,nfull,numdist,sumdim,
     *         numpar,meno,moel,maxxnode,distdim,pardim,parpos,
     *         namepntr(1,ds),nold,xnode,oldname,
     *         parname,rsetname,resname,splname)
         elseif(modeltype(m)/10.eq.5)then
c           Binomial/negative binomial/Poisson model:
            call wrmodel5(levelmax,unit,modeltype(m),nfull,
     *         numdist,sumdim,numpar,meno,moel,maxxnode,distdim,pardim,
     *         parpos,namepntr(1,ds),nold,xnode,oldname,parname,
     *         rsetname,resname,splname,version)
         endif
 
c        Summary statistics of variables that are used in indirect
c        references et cetera.
         if(detail)call write_m_freq(levelmax,modeltype(m),nfreq(m),
     *      maxnumfreq,maxfreqcat,freqloc,namepntr(1,ds),nold,
     *      freqcat,freqs,unit,oldname)
 
  110 continue
 
      num=nfreq(nummodel)/(maxnumfreq+1)
      pos=mod(nfreq(nummodel),maxnumfreq+1)
      if(num.eq.0.or.pos+num.gt.maxnumfreq)write(unit,201)
  201 format(/,'NOTE: not all summary statistics may have been ',
     *   'printed.  Specify',/,'"option maximum number of summary ',
     *   'statistics" sufficiently high.')
 
      if(countint(0,minlnl,nummodel).ne.nummodel.and.
     *   intvecsum(intpnts,sumdim).gt.1)write(unit,202)
  202 format(/,'IMPORTANT: in observations where the likelihood ',
     *   'function contains',/,'outcomes in the denominator, ',
     *   'heterogeneity is integrated out of',/,
     *   'the numerator and denominator separately!')
 
  200 if(unit.eq.6.or.jpt.lt.4)goto 300
      unit=6
      goto 100
 
  300 if(status.ne.0)goto 800
      goto 999
 
  800 if(ipt.gt.0)write(8,801)
      if(jpt.gt.0)write(6,801)
  801 format(/,'ERROR: a multinomial probit model is specified with ',
     *   'model equations',/,'for all outcomes in the data, i.e., ',
     *   'there is no omitted category.  Your',/,'model is ',
     *   'unidentified.  Omit at least one model equation.',/,
     *   '(The multinomial probit algorith requires an omitted ',
     *   'category;',/,'the multinomial logit model would proceed ',
     *   'with only a warning.)',//,
     *   'This message may be suppressed by extraordinarily ',
     *   'experienced aML users.',/,'If you feel this applies to you, ',
     *   'specify "option proficiency=guru;" in',/,'the control file.')
      stop
 
  999 return
      end
