      subroutine writeaia(unit,width,lf,string1,intvar,string2)
 
c     Subroutine to neatly write out a character string followed by
c     an integer and by another character string.  Arguments:
c        unit  [in] unit to which to write
c        width [in] number of columns to be used in writing; if <=0,
c                   no wrapping is done.
c        lf    [in] if =0, no linefeed is written out after string2;
c                   else, linefeed will be written out.
c        string1 [in] first character string
c        intvar  [in] integer to be written
c        string2 [in] second character string
c
c     Note:  if string1(1:5)=='ERROR', a leading linefeed is written.
c
c     Note:  tab characters are counted as one character.
c
c     Constantijn Panis, 7 June 1996
 
      implicit none
      integer unit,width,lf,intvar,column
      character string1*(*),string2*(*)
 
c     If this is an error message, start with blank line:
      if(len(string1).ge.5)then
         if(string1(1:5).eq.'ERROR')write(unit,'(1x)')
      endif
 
c     Write out, wrapping whenever width is exceeded
      column=1
      call wrapstring(unit,column,width,1,0,string1)
      call wrapint(unit,column,width,0,intvar)
      call wrapstring(unit,column,width,0,lf,string2)
 
      return
      end
 
