      subroutine zeroblock(nrow,n1,n2,array)
 
c     Subroutine to set a block in a two-dimensional double precision
c     array to zero.
c
c     Arguments:
c        nrow  [in]  number of rows in array
c        n1    [in]  number of rows of block to be set to zero
c        n2    [in]  number of columns of block to be set to zero
c        array [out] array of which a block needs to be zeroed;
c                    the actual argument must be the top left hand
c                    corner of the block to be zeroed.
c
c     Consider the following array:
c
c              1 2 3 4 5 6 7 8 9 0 1 2 3
c          1 ( x x x x x x x x x x x x x )
c          2 ( x x x x x x x x x x x x x )
c          3 ( x x x x x x x x x x x x x )
c          4 ( x x x x x x x x x x x x x )
c          5 ( x o o o o o o x x x x x x )
c          6 ( x o o o o o o x x x x x x )
c          7 ( x o o o o o o x x x x x x )
c          8 ( x o o o o o o x x x x x x )
c          9 ( x x x x x x x x x x x x x )
c
c     In order to set the elements "o" to zero, call this routine:
c        call zeroblock(9,4,5,array(5,2))
c
c     Constantijn Panis, 15 June 1993
 
      implicit none
      integer nrow,n1,n2,i
      double precision array(nrow,*)
 
      do 100 i=1,n2
         call zerodp(n1,array(1,i))
  100 continue
 
      return
      end
