      subroutine crossinfo(levelmax,datadim,nvar,nx,namepntr,datalevel,
     *   xbase,xmean,xstd,xmin,xmax,name,names,
     *   n,mean,std,minimum,maximum,varywarn)
 
c     Function to compute the mean, std, min, and max of a variable
c     across data structures.  The variable must be level 2+.
c
c     Constantijn Panis, 15 March 1997
c     Last change: account for n-1 degrees of freedom
 
      implicit none
      integer levelmax,datadim,nvar,nx(levelmax,datadim),
     *   namepntr(levelmax,datadim),datalevel(datadim),
     *   xbase(nvar),n,level,dim,i,numvar,vary
      double precision xmean(nvar),xstd(nvar),xmin(nvar),xmax(nvar),
     *   mean,std,minimum,maximum,basis,sumbasis,sumx,sumx2,dpnan
      character name*8,names(nvar)*8,varywarn*8
      logical first
 
      sumbasis=0.d0
      sumx=0.d0
      sumx2=0.d0
      first=.true.
      vary=0
      do 100 dim=1,datadim
         do 110 level=2,datalevel(dim)
            numvar = nx(level,dim)
            if(level.eq.2)numvar=numvar+1
            do 120 i=namepntr(level,dim),namepntr(level,dim)+numvar-1
               if(name.ne.names(i))goto 120
               if(vary.eq.0)then
                  vary=level
               elseif(vary.ne.level)then
                  varywarn=name
               endif
               basis=xbase(i)
               sumbasis=sumbasis+basis
               if(basis.gt.0.d0)then
                  sumx=sumx+basis*xmean(i)
c                 Recall that xstd is based on n-1 degrees of freedom
                  if(basis.gt.1.d0)sumx2=sumx2 +
     *               (basis-1.d0)*xstd(i)*xstd(i)
                  sumx2=sumx2 + basis*xmean(i)*xmean(i)
                  if(first)minimum=xmin(i)
                  if(first)maximum=xmax(i)
                  first=.false.
                  minimum=min(minimum,xmin(i))
                  maximum=max(maximum,xmax(i))
               endif
               mean=xmean(i)
  120       continue
  110    continue
  100 continue
 
      if(sumbasis.gt.0.d0)then
         mean=sumx/sumbasis
         if(sumbasis.le.1.d0)then
            std = dpnan()
         elseif(minimum.eq.maximum)then
            std = 0.d0
         else
            std = sumx2/sumbasis-mean*mean
            std = std*sumbasis/(sumbasis-1.d0)
            std = dsqrt(max(std,0.d0))
         endif
      endif
 
c     Number of values on which cross-summary statistics are based:
      n=int(sumbasis)
 
      return
      end
