      subroutine figure_stats(nvar,datadim,levelmax,nx,namepntr,nobs,
     *   xbase,datalevel,xmean,xstd,xmin,xmax)
 
c     Subroutine to compute means and standard deviations.
c
c     Constantijn Panis, 12 June 1996
 
      implicit none
      integer nvar,datadim,levelmax,nx(levelmax,datadim),
     *   namepntr(levelmax,datadim),nobs,xbase(nvar),
     *   datalevel(datadim),level,dim,num,i
      double precision xmean(nvar),xstd(nvar),xmin(nvar),xmax(nvar),
     *   basis,dbleequiv,dpnan
 
      if(nobs.eq.0)then
         call put(dbleequiv(5555,5555),xmean,nvar)
         goto 999
      endif
 
c     Level 1 variables:
      do 100 i=1,2+nx(1,1)
         basis=xbase(i)
         if(xmin(i).eq.xmax(i))then
            xmean(i) = xmin(i)
         else
            xmean(i) = xmean(i)/basis
         endif
         if(basis.le.1.d0)then
            xstd(i) = dpnan()
         elseif(xmin(i).eq.xmax(i))then
            xstd(i) = 0.d0
         else
            xstd(i) = xstd(i)/basis - xmean(i)*xmean(i)
            xstd(i) = xstd(i)*basis/(basis-1.d0)
            xstd(i) = dsqrt(max(xstd(i),0.d0))
         endif
  100 continue
 
c     Level 2+ variables:
      do 200 dim=1,datadim
         do 220 level=2,datalevel(dim)
            num = nx(level,dim)
            if(level.eq.2)num=num+1
            do 230 i=namepntr(level,dim),namepntr(level,dim)-1+num
               basis=xbase(i)
               if(basis.eq.0.d0)then
                  xmean(i)=dbleequiv(5555,5555)
                  goto 230
               endif
               if(xmin(i).eq.xmax(i))then
                  xmean(i) = xmin(i)
               else
                  xmean(i) = xmean(i)/basis
               endif
               if(basis.le.1.d0)then
                  xstd(i) = dpnan()
               elseif(xmin(i).eq.xmax(i))then
                  xstd(i)=0.d0
               else
                  xstd(i) = xstd(i)/basis - xmean(i)*xmean(i)
                  xstd(i) = xstd(i)*basis/(basis-1.d0)
                  xstd(i) = dsqrt(max(xstd(i),0.d0))
               endif
  230       continue
  220    continue
  200 continue
 
  999 return
      end
