      subroutine getnbmax(levelmax,nbmax,nbdim,nb,branch)
 
c     Subroutine to determine ((nbmax(i,j), j=2,levelmax), i=1,levelmax-1),
c     where nbmax(i,j) is the maximum number of level j branches in any
c     level i branch.
c
c     Constantijn Panis, 11 July 1996
 
      implicit none
      integer levelmax,nbmax(levelmax-1,2:levelmax),nbdim,nb(nbdim,2),
     *   branch(levelmax-1),ll,i,j,num,nmbrnch
 
c     First keep track of numbers of subbbranches in any one observation:
      do 100 ll=2,levelmax
         num=nmbrnch(1,branch,ll,nbdim,nb)
         nbmax(1,ll)=max(nbmax(1,ll),num)
  100 continue
 
      if(levelmax.le.2)goto 999
 
c     Initialize: start with first branch at each level.
      call putint(1,branch(2),levelmax-3)
      branch(levelmax-1)=0
 
      ll=levelmax-1
  200 branch(ll)=branch(ll)+1
      if(branch(ll).gt.nmbrnch(ll-1,branch,ll,nbdim,nb))then
c        Increment next higher level:
         ll=ll-1
         if(ll.eq.1)goto 999
         goto 200
      elseif(ll.lt.levelmax-1)then
c        Start out at first of each subbranch:
         call putint(1,branch(ll+1),levelmax-ll-1)
         ll=levelmax-1
      endif
 
      do 210 i=2,levelmax-1
         do 220 j=i+1,levelmax
c           Number of level j branches in this level i branch:
            num=nmbrnch(i,branch,j,nbdim,nb)
            if(num.eq.0)goto 210
            nbmax(i,j)=max(nbmax(i,j),num)
  220    continue
  210 continue
      goto 200
 
  999 return
      end
