      subroutine nb2nblong(levelmax,maxnbdim,datadim,nbdim,nb2,
     *   nb,nblong,ds,datalevel)
 
c     Subroutine to place nb into long array nblong, which will be part
c     of the data.  Nb was read in branch-by-branch in read_obs; the
c     information needs to be rearranged by level.
c
c     Constantijn Panis, 3 July 1996
 
      implicit none
      integer levelmax,maxnbdim,datadim,nbdim,nb2,nb(maxnbdim,nb2),
     *   nblong(nbdim,2),ds(nb2),dsib,
     *   datalevel(datadim),pos,num,begin,i,level,ib2,refpos,
     *   numbranch,dimnb
 
c     nblong represents one level 1 record (one observation);  the second
c     column points at relevant position in first column to get to number
c     of branches at next lower level:
      nblong(1,1)=1
      nblong(1,2)=2
c     There are nb2 level 2 branches; level 3 information starts at row 3:
      nblong(2,1)=nb2
      nblong(2,2)=3
c     Assign one location for each level 2 branch.  The reason for this
c     is that level 2 data structures will have no further information,
c     which would throw nmbrnch off.  This won't be the case, though,
c     if all data structures are level 2:
      if(levelmax.le.2)goto 999
      pos=2
      refpos=nb2+3
      do 100 ib2=1,nb2
         dsib=ds(ib2)
         pos=pos+1
         if(datalevel(dsib).eq.2)then
            nblong(pos,1)=0
            nblong(pos,2)=0
         elseif(datalevel(dsib).eq.3)then
            nblong(pos,1)=nb(1,ib2)
            nblong(pos,2)=0
         else
            nblong(pos,1)=nb(1,ib2)
            nblong(pos,2)=refpos
            refpos=refpos+nblong(pos,1)
         endif
  100 continue
 
      do 200 level=4,levelmax
         do 210 ib2=1,nb2
            dsib=ds(ib2)
            if(datalevel(dsib).lt.level)goto 210
c           How many level level-1 branches are there in this level 2 branch
c           which will have information on the next level?
            num=numbranch(level-1,nb(1,ib2))
c           Where in nb do these branches start?
            begin=dimnb(level-1,nb(1,ib2))
            do 220 i=1,num
               pos=pos+1
               nblong(pos,1)=nb(begin+i,ib2)
               if(nblong(pos,1).eq.0.or.datalevel(dsib).eq.level)then
c                 There is no more information:
                  nblong(pos,2)=0
               else
c                 Information on the next level starts at row refpos:
                  nblong(pos,2)=refpos
                  refpos=refpos+nblong(pos,1)
               endif
  220       continue
  210    continue
  200 continue
 
  999 return
      end
