      subroutine readrect(unit,id,struc,level,nbr,nb,nx,
     *   maxnbdim,nbdim,maxxdim,xdim,x,status)
 
c     Subroutine to read in ID, [structure,] [numbers of branches,]
c     and variables X, in rectangular format.
c
c     status [out]  0 = all is OK
c                   1 = ID or structure not what was expected
c                   2 = insufficient space available to store nb or X
c                   3 = read error or end-of-file (should not happen!)
c
c     Constantijn Panis, 17 November 2000
c     Last change: X1 now part of X.
 
      implicit none
      integer unit,id,struc,level,nbr(level),nb(*),nx(level),
     *   maxnbdim,maxxdim,xdim,status,ll,nbdim,intvecprod
      real x(maxxdim)
 
      status=0
c     First compute the number of elements of nb and the number
c     of X values to read in.
      if(level.eq.1)then
         nbdim=0
         xdim=nx(1)
      elseif(level.eq.2)then
         nbdim=0
         xdim=nx(1)+nx(2)
      else
         nbdim=1
         do 100 ll=3,level-1
            nbdim=nbdim+intvecprod(nbr(3),ll-2)
  100    continue
         xdim=nx(1)+nx(2)
         do 200 ll=3,level
            xdim=xdim+nx(ll)*intvecprod(nbr(3),ll-2)
  200    continue
      endif
 
      if(xdim.gt.maxxdim.or.nbdim.gt.maxnbdim)then
         status=2
         goto 999
      endif
 
c     Then read in the numbers:
      call readrect_(unit,id,struc,level,nbdim,xdim,nb,x,status)
 
  999 return
      end
c==========================================================================
      subroutine readrect_(unit,id,struc,level,nbdim,xdim,nb,x,status)
 
      implicit none
      integer unit,id,struc,level,nbdim,xdim,nb(nbdim),status
      double precision thisid,thisstruc
      real x(xdim)
 
      if(struc.eq.0)then
         if(level.eq.2)then
            read(unit,*,end=800,err=800)thisid,x
         else
            read(unit,*,end=800,err=800)thisid,nb,x
         endif
         if(thisid.ne.dble(id))status=1
      else
         if(level.eq.2)then
            read(unit,*,end=800,err=800)thisid,thisstruc,x
         else
            read(unit,*,end=800,err=800)thisid,thisstruc,nb,x
         endif
         if(thisid.ne.dble(id).or.thisstruc.ne.dble(struc))status=1
      endif
 
      goto 999
 
  800 status=3
  999 return
      end
