      subroutine figure_pos(maxcc,ccmax,numnest,numdist,sumbigintdim,
     *   nested,distdim,distyp,lamtyp,ndraw,lampos,ne,neh,nel,nep,nec,
     *   neb,nen,nepo,neml,nneml,dimscr,dimarar,dimii,dimlam,siga4a4,
     *   dsiga4a4,ddsiga4a4,tau,dtau,ddtau,siga6a6,dsiga6a6,ddsiga6a6,
     *   sigil6,dsigil6,sigarar,dsigarar,sigl4l6,dsigl4l6,ddsigl4l6,lam,
     *   dlam,ddlam,epsh,ddepsh,epsl,ddepsl,epsp,ddepsp,epsc,ddepsc,
     *   epsb,ddepsb,epsn,ddepsn,epspo,ddepspo,epsml,ddepsml,sigii,
     *   dsigii,ddsigii,a6,da6,siga6a6ia6,cmui,dcmui,ddcmui,cmua4,
     *   sigl4l6a6a6i,iid4,ipt,jpt)
 
c     Subroutine to determine beginning positions in scratch arrays
c     scr/dscr/ddscr for all kinds of scratch arrays used in
c     ithobs.  Generally speaking, arrays of constant dimension (over
c     all observations) are allocated in mklocdim; the current routine
c     covers arrays of variable dimension.
c
c     Naming conventions:
c        d  = residual, as Defined by the user
c        e  = residual, Expanded (multiple draws)  (in concept only)
c        ar = CAR/ARMA residual
c        l4 = probit residual, Loaded
c        a4 = probit residual, Accumulated (over distributions)
c        l6 = continuous residual, Loaded
c        a6 = continuous residual, Accumulated (over distributions)
c        i  = Integrated residual, compressed (i.e., only those
c             dimensions for which dimused>0 are present.)
c        i6 = Integrated continuous residual, loaded (!)
c
c     Constantijn Panis, 11 November 2002
c     Last change: Poisson
 
      implicit none
      integer maxcc,ccmax,numnest,numdist,nested(numdist),
     *   distdim(numdist),distyp(numdist),ndraw(numdist),
     *   lamtyp(numdist,8),lampos(numdist,8),ne,neh,nel,nep,nec,neb,
     *   nen,nepo,neml,nneml,dimscr,dimarar,dimii,dimlam,ipt,jpt,dim,
     *   bigdim,sumbigintdim,i,lamtypdim
      integer siga4a4,dsiga4a4,ddsiga4a4,tau,dtau,ddtau,siga6a6,
     *   dsiga6a6,ddsiga6a6,sigil6,dsigil6,sigarar,dsigarar,sigl4l6,
     *   dsigl4l6,ddsigl4l6,lam,dlam,ddlam,epsh,ddepsh,epsl,ddepsl,epsp,
     *   ddepsp,epsc,ddepsc,epsb,ddepsb,epsn,ddepsn,epspo,ddepspo,
     *   epsml,ddepsml,sigii,dsigii,ddsigii,a6,da6,siga6a6ia6,cmui,
     *   dcmui,ddcmui,cmua4,sigl4l6a6a6i
      logical iid4
 
      dimii=0
      dimarar=0
      sumbigintdim=0
      if(numdist.eq.0)then
         dimlam=0
      else
c        Dimension of residual load matrices and pointers to them:
         lampos(1,1)=0
         do 100 i=1,numdist
            dim=distdim(i)
            bigdim=dim*ndraw(i)
            if(nested(i).gt.0)then
               sumbigintdim=sumbigintdim+bigdim
               dimii=dimii+bigdim*bigdim
            endif
            if(mod(distyp(i),10).eq.2.or.mod(distyp(i),10).eq.3)
     *         dimarar=dimarar+bigdim*bigdim
            lampos(i,2)=lampos(i,1)+lamtypdim(neh,bigdim,lamtyp(i,1))
            lampos(i,3)=lampos(i,2)+lamtypdim(nel,bigdim,lamtyp(i,2))
            lampos(i,4)=lampos(i,3)+lamtypdim(nep,bigdim,lamtyp(i,3))
            lampos(i,5)=lampos(i,4)+lamtypdim(nec,bigdim,lamtyp(i,4))
            lampos(i,6)=lampos(i,5)+lamtypdim(neb,bigdim,lamtyp(i,5))
            lampos(i,7)=lampos(i,6)+lamtypdim(nen,bigdim,lamtyp(i,6))
            lampos(i,8)=lampos(i,7)+lamtypdim(nepo,bigdim,lamtyp(i,7))
            if(i.lt.numdist)then
               lampos(i+1,1)=
     *            lampos(i,8)+lamtypdim(nneml,bigdim,lamtyp(i,8))
            else
               dimlam=lampos(i,8)+lamtypdim(nneml,bigdim,lamtyp(i,8))
            endif
  100    continue
      endif
 
c     Allocate space for double precision arrays:
      siga4a4=ccmax/8+2
      dsiga4a4=siga4a4+nep*nep
      ddsiga4a4=dsiga4a4+nep*nep*(1+numnest)
      tau=ddsiga4a4+nep*nep*numnest
      dtau=tau+2*(nel+nep)
      ddtau=dtau+2*(nel+nep)*(1+numnest)
      a6=ddtau+2*(nel+nep)*numnest
      da6=a6+nec
      siga6a6=da6+nec
      dsiga6a6=siga6a6+nec*nec
      ddsiga6a6=dsiga6a6+nec*nec*(1+numnest)
      sigil6=ddsiga6a6+nec*nec*numnest
      dsigil6=sigil6+sumbigintdim*nec
      sigarar=dsigil6+sumbigintdim*nec
      dsigarar=sigarar+dimarar
      if(nec.gt.0.and.nep.gt.0.and..not.iid4)then
         sigl4l6=dsigarar+dimarar
         dsigl4l6=sigl4l6+numdist*nep*nec
         ddsigl4l6=dsigl4l6+numdist*nep*nec*numnest
         lam=ddsigl4l6+numdist*nep*nec*numnest
      else
         sigl4l6=dsigarar+dimarar
         dsigl4l6=sigl4l6
         ddsigl4l6=dsigl4l6
         lam=ddsigl4l6
      endif
      dlam=lam+dimlam
      ddlam=dlam+dimlam*numnest
      epsh=ddlam+dimlam*numnest
      ddepsh=epsh+neh
      epsl=ddepsh+neh
      ddepsl=epsl+nel
      epsp=ddepsl+nel
      ddepsp=epsp+nep
      epsc=ddepsp+nep
      ddepsc=epsc+nec
      epsb=ddepsc+nec
      ddepsb=epsb+neb
      epsn=ddepsb+neb
      ddepsn=epsn+nen
      epspo=ddepsn+nen
      ddepspo=epspo+nepo
      epsml=ddepspo+nepo
      ddepsml=epsml+nneml
      sigii=ddepsml+nneml
      dsigii=sigii+dimii
      ddsigii=dsigii+dimii*numnest
      a6=ddsigii+dimii*(numnest-1)
      siga6a6ia6=a6+nec
      sigl4l6a6a6i=siga6a6ia6+nec
      cmui=sigl4l6a6a6i+max(nep,sumbigintdim)*nec
      dcmui=cmui+sumbigintdim
      ddcmui=dcmui+sumbigintdim*numnest
      cmua4=ddcmui+sumbigintdim*numnest
 
c     Note:  do not update ccmax here, as it would accumulate over
c     observations.  The dimension of cmua4 is nep.
      if(8*(cmua4+nep).gt.maxcc)call
     *   needmemory(maxcc,8*(cmua4+nep),ne,ipt,jpt)
 
c     Check total dimensions against subroutine checkdims:
      if(dimscr.ne.cmua4+nep-siga4a4)call bug(ipt,jpt)
 
  999 return
      end
