      subroutine mklocdim(task,maxcc,ccmax,locdim,nfullplus,ipt,jpt,
     *   scrnobs,maxpnts,numspl,numdist,maxnest,numarma,sumdim,
     *   sumintdim,sumdim2,sumdim4,vdimmax,nihmax,nemax,nehmax,nelmax,
     *   nepmax,necmax,nebmax,nenmax,nepomax,nemlmax,nnemlmax,
     *   maxxnode,maxnmapmoel,maxds,nngammax,rsh3max,rsh4max,rsh5max,
     *   rsnamax,rsnpmax,scrdim,rspmax,rscmax,rsmlmax,
     *   allint6,z,wt,weight,scaleweight,xnode,v,intpnts,intpntr,
     *   dimused,mapmoel,nested,distpos,distdim,ndraw,distyp,lamtyp,
     *   distrestr,distrestrpos,numpar,pardim,parpos,parname,fullname,
     *   refspl,beginspl,nodepos,numnodes,spltype,iflam,ifint4,ifint6,
     *   iftau,iid4,posdef,like,lnl,dfullbeta,ddfullbeta,lnla,lnlb,xbh3,
     *   xbh4,xbh5,d1xbh3,d2xbh3,gamma,d1gamma,d2gamma,s,ds,ssg,dlnla,
     *   dlnlb,ui,ddui,sigdd,dsigdd,stda4,cdm,ddcdm,dcdmdsigii,dxbh,
     *   ddxbh,xblp,dxblp,ddxblp,xbc,dxbc,ddxbc,a5,da5,dda5,p5,dp5,ddp5,
     *   xbml,dxbml,ddxbml,indx,lampos,bdc,thisdraw,intdist,draw,cdraw)
 
c     Subroutine to:
c     task = 1: copy locations and dimensions into locdim(); this
c               is the only array (apart from dd,rr,ii,ll,cc) that is
c               passed on to the likelihood function.
c     task = 2: copy array locdim back into locations and dimensions.
c
c     Constantijn Panis, 11 November 2002
c     Last change: Poisson
 
      implicit none
c     maxcc is the size of the big scratch array that is set equivalent
c     to dd, rr, ii, ll, and cc.
      integer task,maxcc,ccmax,locdim(120),nfullplus,ipt,jpt
      integer scrnobs,maxpnts,numspl,numdist,maxnest,numarma,sumdim,
     *   sumintdim,sumdim2,sumdim4,vdimmax,nihmax,nemax,nehmax,nelmax,
     *   nepmax,necmax,nebmax,nenmax,nepomax,nemlmax,nnemlmax,maxxnode,
     *   maxnmapmoel,maxds,nngammax,rsh3max,rsh4max,rsh5max,rsnamax,
     *   rsnpmax,scrdim,rspmax,rscmax,rsmlmax,allint6
      integer z,wt,weight,scaleweight,xnode,v,intpnts,intpntr,dimused,
     *   mapmoel,nested,distpos,distdim,ndraw,distyp,lamtyp,distrestr,
     *   distrestrpos,numpar,pardim,parpos,parname,fullname,refspl,
     *   beginspl,nodepos,numnodes,spltype,iflam,ifint4,ifint6,iftau,
     *   iid4,posdef
      integer like,lnl,dfullbeta,ddfullbeta,
     *   lnla,lnlb,xbh3,xbh4,xbh5,d1xbh3,d2xbh3,gamma,d1gamma,
     *   d2gamma,s,ds,ssg,dlnla,dlnlb,ui,ddui,sigdd,dsigdd,stda4,
     *   cdm,ddcdm,dcdmdsigii,dxbh,ddxbh,xblp,dxblp,ddxblp,
     *   xbc,dxbc,ddxbc,a5,da5,dda5,p5,dp5,ddp5,xbml,dxbml,ddxbml,
     *   indx,lampos,bdc,thisdraw,intdist,draw,cdraw
 
      if(task.eq.2)goto 200
 
c     Create locdim.
c     First allocate sufficient memory space for various arrays,
c     starting with double precision variables and arrays:
      like=ccmax/8+2
      lnl=like+maxnest
      weight=lnl+(1+maxnest)
      dfullbeta=weight+maxnest
      ddfullbeta=dfullbeta+nfullplus*(1+maxnest)
      lnla=ddfullbeta+nfullplus*maxnest
      lnlb=lnla+nehmax
      xbh3=lnlb+nehmax
      xbh4=xbh3+(nihmax*(1+rsh3max))
      xbh5=xbh4+(nehmax*rsh4max)
      d1xbh3=xbh5+(nehmax*rsh5max)
      d2xbh3=d1xbh3+nihmax
      gamma=d2xbh3+nihmax
      d1gamma=gamma+nngammax
      d2gamma=d1gamma+nngammax
      s=d2gamma+nngammax
      ds=s+nihmax+1
      ssg=ds+maxds
      dlnla=ssg+nihmax
      dlnlb=dlnla+nehmax*nfullplus
      ui=dlnlb+nehmax*nfullplus
      ddui=ui+sumintdim
      sigdd=ddui+sumintdim
      dsigdd=sigdd+sumdim2
      stda4=dsigdd+sumdim2
      cdm=stda4+nepmax
c     cdm, ddcdm, and dcdmdsigii only apply to integrated distributions;
c     their dimensions could thus be slightly smaller, e.g., sum(intdim^2).
      ddcdm=cdm+sumdim2
      dcdmdsigii=ddcdm+sumdim2
      dxbh=dcdmdsigii+sumdim4
      ddxbh=dxbh+nehmax*(1+maxnest)
      xblp=ddxbh+nehmax*maxnest
      dxblp=xblp+(nelmax+nepmax)*(1+rspmax)
      ddxblp=dxblp+(nelmax+nepmax)*(1+maxnest)
      xbc=ddxblp+(nelmax+nepmax)*maxnest
      dxbc=xbc+necmax*(1+rscmax)
      ddxbc=dxbc+necmax*(1+maxnest)
      a5=ddxbc+necmax*maxnest
      da5=a5+nenmax*(1+rsnamax)
      dda5=da5+nenmax*(1+maxnest)
      p5=dda5+nenmax*maxnest
      dp5=p5+(nebmax+nenmax+nepomax)*(1+rsnpmax)
      ddp5=dp5+(nebmax+nenmax+nepomax)*(1+maxnest)
      xbml=ddp5+(nebmax+nenmax+nepomax)*maxnest
      dxbml=xbml+nnemlmax*(1+rsmlmax)
      ddxbml=dxbml+nnemlmax*(1+maxnest)
c     The dimension of ddxbml is nnemlmax*maxnest:
      ccmax=8*(ddxbml+nnemlmax*maxnest)
 
c     Integer variables and arrays:
      indx=ccmax/4+2
      lampos=indx+sumintdim
      bdc=lampos+8*numdist
      thisdraw=bdc+nepmax
      intdist=thisdraw+numdist
c     The dimension of intdist is maxnest
      ccmax=4*(intdist+maxnest)
 
      locdim(1)   = nfullplus
      locdim(2)   = scrnobs
      locdim(3)   = maxpnts
      locdim(4)   = numspl
      locdim(5)   = numdist
      locdim(6)   = numarma
      locdim(7)   = sumintdim
      locdim(8)   = sumdim2
      locdim(9)   = vdimmax
      locdim(10)  = nihmax
      locdim(11)  = nemax
      locdim(12)  = nehmax
      locdim(13)  = nelmax
      locdim(14)  = nepmax
      locdim(15)  = necmax
      locdim(16)  = nebmax
      locdim(17)  = nenmax
      locdim(18)  = nepomax
      locdim(19)  = maxxnode
      locdim(20)  = maxnmapmoel
      locdim(21)  = maxds
      locdim(22)  = nngammax
      locdim(23)  = rsh3max
      locdim(24)  = rsh4max
      locdim(25)  = rsh5max
      locdim(26)  = rsnamax
      locdim(27)  = rsnpmax
      locdim(28)  = rsmlmax
      locdim(29)  = scrdim
      locdim(30)  = rspmax
      locdim(31)  = rscmax
      locdim(32)  = z
      locdim(33)  = wt
      locdim(34)  = scaleweight
      locdim(35)  = xnode
      locdim(36)  = v
      locdim(37)  = intpnts
      locdim(38)  = intpntr
      locdim(39)  = dimused
      locdim(40)  = mapmoel
      locdim(41)  = nested
      locdim(42)  = distpos
      locdim(43)  = distdim
      locdim(44)  = ndraw
      locdim(45)  = distyp
      locdim(46)  = lamtyp
      locdim(47)  = distrestr
      locdim(48)  = distrestrpos
      locdim(49)  = numpar
      locdim(50)  = pardim
      locdim(51)  = parpos
      locdim(52)  = parname
      locdim(53)  = fullname
      locdim(54)  = refspl
      locdim(55)  = beginspl
      locdim(56)  = nodepos
      locdim(57)  = numnodes
      locdim(58)  = spltype
      locdim(59)  = iflam
      locdim(60)  = ifint6
      locdim(61)  = iftau
      locdim(62)  = iid4
      locdim(63)  = posdef
      locdim(64)  = dfullbeta
      locdim(65)  = ddfullbeta
      locdim(66)  = lnla
      locdim(67)  = lnlb
      locdim(68)  = xbh3
      locdim(69)  = xbh4
      locdim(70)  = xbh5
      locdim(71)  = d1xbh3
      locdim(72)  = d2xbh3
      locdim(73)  = gamma
      locdim(74)  = d1gamma
      locdim(75)  = d2gamma
      locdim(76)  = s
      locdim(77)  = ds
      locdim(78)  = ssg
      locdim(79)  = dlnla
      locdim(80)  = dlnlb
      locdim(81)  = ui
      locdim(82)  = ddui
      locdim(83)  = sigdd
      locdim(84)  = dsigdd
      locdim(85)  = stda4
      locdim(86)  = cdm
      locdim(87)  = ddcdm
      locdim(88)  = dcdmdsigii
      locdim(89)  = dxbh
      locdim(90)  = ddxbh
      locdim(91)  = xblp
      locdim(92)  = dxblp
      locdim(93)  = ddxblp
      locdim(94)  = xbc
      locdim(95)  = dxbc
      locdim(96)  = ddxbc
      locdim(97)  = a5
      locdim(98)  = da5
      locdim(99)  = dda5
      locdim(100)  = p5
      locdim(101)  = dp5
      locdim(102) = ddp5
      locdim(103) = xbml
      locdim(104) = dxbml
      locdim(105) = ddxbml
      locdim(106) = indx
      locdim(107) = lampos
      locdim(108) = bdc
      locdim(109) = thisdraw
      locdim(110) = intdist
      locdim(111) = draw
      locdim(112) = cdraw
      locdim(113) = sumdim4
      locdim(114) = ifint4
      locdim(115) = allint6
      locdim(116) = maxnest
      locdim(117) = like
      locdim(118) = lnl
      locdim(119) = weight
c     There must not be more than 120 elements in locdim.
 
      if(ccmax.gt.maxcc)call needmemory(maxcc,ccmax,nemax,ipt,jpt)
 
c     Assign locdim:
      goto 999
 
c     Map locdim back into meaningful names:
  200 continue
      nfullplus = locdim(1)
      scrnobs = locdim(2)
      maxpnts = locdim(3)
      numspl = locdim(4)
      numdist = locdim(5)
      numarma = locdim(6)
      sumintdim = locdim(7)
      sumdim2 = locdim(8)
      vdimmax = locdim(9)
      nihmax = locdim(10)
      nemax = locdim(11)
      nehmax = locdim(12)
      nelmax = locdim(13)
      nepmax = locdim(14)
      necmax = locdim(15)
      nebmax = locdim(16)
      nenmax = locdim(17)
      nepomax = locdim(18)
      maxxnode = locdim(19)
      maxnmapmoel = locdim(20)
      maxds = locdim(21)
      nngammax = locdim(22)
      rsh3max = locdim(23)
      rsh4max = locdim(24)
      rsh5max = locdim(25)
      rsnamax = locdim(26)
      rsnpmax = locdim(27)
      rsmlmax = locdim(28)
      scrdim = locdim(29)
      rspmax = locdim(30)
      rscmax = locdim(31)
      z = locdim(32)
      wt = locdim(33)
      scaleweight = locdim(34)
      xnode = locdim(35)
      v = locdim(36)
      intpnts = locdim(37)
      intpntr = locdim(38)
      dimused = locdim(39)
      mapmoel = locdim(40)
      nested = locdim(41)
      distpos = locdim(42)
      distdim = locdim(43)
      ndraw = locdim(44)
      distyp = locdim(45)
      lamtyp = locdim(46)
      distrestr = locdim(47)
      distrestrpos = locdim(48)
      numpar = locdim(49)
      pardim = locdim(50)
      parpos = locdim(51)
      parname = locdim(52)
      fullname = locdim(53)
      refspl = locdim(54)
      beginspl = locdim(55)
      nodepos = locdim(56)
      numnodes = locdim(57)
      spltype = locdim(58)
      iflam = locdim(59)
      ifint6 = locdim(60)
      iftau = locdim(61)
      iid4 = locdim(62)
      posdef = locdim(63)
      dfullbeta = locdim(64)
      ddfullbeta = locdim(65)
      lnla = locdim(66)
      lnlb = locdim(67)
      xbh3 = locdim(68)
      xbh4 = locdim(69)
      xbh5 = locdim(70)
      d1xbh3 = locdim(71)
      d2xbh3 = locdim(72)
      gamma = locdim(73)
      d1gamma = locdim(74)
      d2gamma = locdim(75)
      s = locdim(76)
      ds = locdim(77)
      ssg = locdim(78)
      dlnla = locdim(79)
      dlnlb = locdim(80)
      ui = locdim(81)
      ddui = locdim(82)
      sigdd = locdim(83)
      dsigdd = locdim(84)
      stda4 = locdim(85)
      cdm = locdim(86)
      ddcdm = locdim(87)
      dcdmdsigii = locdim(88)
      dxbh = locdim(89)
      ddxbh = locdim(90)
      xblp = locdim(91)
      dxblp = locdim(92)
      ddxblp = locdim(93)
      xbc = locdim(94)
      dxbc = locdim(95)
      ddxbc = locdim(96)
      a5 = locdim(97)
      da5 = locdim(98)
      dda5 = locdim(99)
      p5 = locdim(100)
      dp5 = locdim(101)
      ddp5 = locdim(102)
      xbml = locdim(103)
      dxbml = locdim(104)
      ddxbml = locdim(105)
      indx = locdim(106)
      lampos = locdim(107)
      bdc = locdim(108)
      thisdraw = locdim(109)
      intdist = locdim(110)
      draw = locdim(111)
      cdraw = locdim(112)
      sumdim4 = locdim(113)
      ifint4 = locdim(114)
      allint6 = locdim(115)
      maxnest = locdim(116)
      like = locdim(117)
      lnl = locdim(118)
      weight = locdim(119)
 
c     Ensure that sufficient space is available.
      if(ccmax+8*scrdim.gt.maxcc)call needmemory(maxcc,ccmax+8*scrdim,
     *   nemax,ipt,jpt)
 
  999 return
      end
