      subroutine writeprep(maxcc,ccmax,dd,rr,ii,cc,levelmax,dimmax,
     *   maxref,nold,ipt,jpt,amlversion,r2aversion,version,prof,datadim,
     *   nummodel,ngrid,nfull,datanobs,nobs,numspl,numrset,numpar,
     *   numdist,sumdim,wghtpos,convcrit,grid,fullbeta,originstats,
     *   rsetstats,xnode,sumweight,scaleweight,mdllvl,strucfreqs,
     *   iiffull,gridpos,distpos,distdim,distyp,distrestrpos,distrestr,
     *   resref,intpnts,rsetref,rsetbegin,rsetnum,maxxnode,parref,
     *   parpos,pardim,fulltype,splref,beginspl,nodepos,numnodes,
     *   spltype,datas,strctre,moel,datastructure,moelpntr,modeltype,
     *   minlnl,namepntr,maxnfreq,maxfreqcat,nfreq,freqloc,
     *   freqcat,freqs,detail,amlfile,dsn,title,rundate,datadate,
     *   oldname,fullname,rsetname,splname,distvar,
     *   resname,parname,gridfile)
 
c     Subroutine to write out the following:
c        general information, including version of aml
c        frequency table of data structures in the data and estimation
c        which variables are in deviations from means
c        model element definitions and some summary statistics
c        starting values
c
c     Constantijn Panis, 21 January 2006
c     Last change: remove license issues
 
      implicit none
c     maxcc is the size of the big scratch array that is set equivalent
c     to dd, rr, ii, ll, and cc.
      integer maxcc,ccmax
      double precision dd(maxcc/8)
      real rr(maxcc/4)
      integer ii(maxcc/4)
      character cc(maxcc)*1
      double precision convcrit(4,2)
c     Actual integers:
      integer levelmax,dimmax,maxref,nold,ipt,jpt,amlversion,datadim,
     *   r2aversion,version,prof,nummodel,ngrid,nfull,datanobs,nobs,
     *   numspl,numrset,numpar,numdist,sumdim,wghtpos,intpnts,maxxnode,
     *   maxnfreq,maxfreqcat
c     Integers that are pointers to arrays:
      integer grid,fullbeta,originstats,rsetstats,xnode,mdllvl,
     *   strucfreqs,iiffull,gridpos,distpos,distdim,distyp,distrestrpos,
     *   distrestr,resref,rsetref,rsetbegin,rsetnum,parref,
     *   parpos,pardim,fulltype,splref,beginspl,nodepos,numnodes,
     *   spltype,datas,strctre,moel,datastructure,moelpntr,modeltype,
     *   minlnl,namepntr,nfreq,freqloc,freqcat,freqs,
     *   oldname,fullname,corrname,rsetname,splname,distvar,
     *   resname,parname,sumweight,scaleweight
      logical detail
      character title*80,dsn*128,gridfile*128,amlfile*128,rundate*24,
     *   datadate*24
 
c     Real arrays:
      scaleweight=ccmax/4+2
c     The dimension of scaleweight is 1:
      ccmax=4*(scaleweight+1)
c     Character arrays:
      corrname=ccmax+2
c     The dimension of corrname is (dimmax,dimmax)*8, but this scratch
c     array is only used in this subroutine, to the space may be released:
      ccmax=corrname+8*dimmax*dimmax
      if(ccmax.gt.maxcc)call needmemory(maxcc,ccmax,0,ipt,jpt)
      ccmax=corrname-2
 
      call writeprep_(levelmax,dimmax,maxref,nold,ipt,jpt,amlversion,
     *   r2aversion,version,prof,datadim,nummodel,ngrid,nfull,datanobs,
     *   nobs,numspl,numrset,numpar,numdist,sumdim,wghtpos,convcrit,
     *   dd(grid),dd(fullbeta),dd(originstats),dd(rsetstats),rr(xnode),
     *   rr(sumweight),rr(scaleweight),ii(mdllvl),ii(strucfreqs),
     *   ii(iiffull),ii(gridpos),ii(distpos),ii(distdim),ii(distyp),
     *   ii(distrestrpos),ii(distrestr),ii(resref),ii(intpnts),
     *   ii(rsetref),ii(rsetbegin),ii(rsetnum),
     *   maxxnode,ii(parref),ii(parpos),ii(pardim),ii(fulltype),
     *   ii(splref),ii(beginspl),ii(nodepos),ii(numnodes),ii(spltype),
     *   ii(datas),ii(strctre),ii(moel),rr(datastructure),
     *   ii(moelpntr),ii(modeltype),ii(minlnl),ii(namepntr),
     *   maxnfreq,maxfreqcat,ii(nfreq),ii(freqloc),
     *   rr(freqcat),ii(freqs),detail,amlfile,
     *   dsn,title,rundate,datadate,cc(oldname),
     *   cc(fullname),cc(corrname),cc(rsetname),cc(splname),
     *   cc(distvar),cc(resname),cc(parname),
     *   gridfile)
      goto 999
 
  999 return
      end
c=======================================================================
      subroutine writeprep_(levelmax,dimmax,maxref,nold,ipt,jpt,
     *   amlversion,r2aversion,version,prof,datadim,nummodel,ngrid,
     *   nfull,datanobs,nobs,numspl,numrset,numpar,numdist,sumdim,
     *   wghtpos,convcrit,grid,fullbeta,originstats,rsetstats,xnode,
     *   sumweight,scaleweight,mdllvl,strucfreqs,iiffull,gridpos,
     *   distpos,distdim,distyp,distrestrpos,distrestr,resref,intpnts,
     *   rsetref,rsetbegin,rsetnum,maxxnode,parref,parpos,pardim,
     *   fulltype,splref,beginspl,nodepos,numnodes,spltype,datas,
     *   strctre,moel,datastructure,moelpntr,modeltype,minlnl,namepntr,
     *   maxnfreq,maxfreqcat,nfreq,freqloc,freqcat,freqs,detail,amlfile,
     *   dsn,title,rundate,datadate,oldname,fullname,corrname,
     *   rsetname,splname,distvar,resname,parname,
     *   gridfile)
 
c     Subroutine to write out the following:
c        general information, including version of aml
c        frequency table of data structures in the data and estimation
c        which variables are in deviations from means
c        model element definitions and some summary statistics
c        starting values
 
      implicit none
      integer levelmax,dimmax,maxref,nold,ipt,jpt,amlversion,
     *   r2aversion,version,prof,datadim,nummodel,ngrid,nfull,datanobs,
     *   nobs,numspl,numrset,numpar,maxfreqcat,maxnfreq,numdist,sumdim,
     *   wghtpos
      double precision convcrit(4,2),grid(ngrid,2),fullbeta(nfull),
     *   originstats(5,numspl),rsetstats(5,nfull)
      real xnode(*),freqcat(maxfreqcat,maxnfreq),datastructure(datadim),
     *   sumweight,scaleweight
      integer mdllvl(nummodel),strucfreqs(datadim,3),iiffull(nfull),
     *   gridpos(ngrid,2),distpos(numdist),distdim(numdist),
     *   distyp(numdist),distrestrpos(numdist),distrestr(0:*),
     *   resref(maxref),intpnts(sumdim),rsetref(maxref),
     *   rsetbegin(numrset),rsetnum(numrset),
     *   maxxnode,parref(maxref),parpos(numpar),pardim(numpar),
     *   fulltype(nfull),splref(maxref),beginspl(numspl),
     *   nodepos(numspl),
     *   numnodes(numspl),spltype(numspl),datas(nummodel),
     *   strctre(nummodel),moel(*),
     *   moelpntr(nummodel),modeltype(nummodel),minlnl(nummodel),
     *   namepntr(levelmax,datadim),
     *   nfreq(0:nummodel),freqloc(maxnfreq),freqs(maxfreqcat,maxnfreq)
      logical detail
      character amlfile*128,dsn*128,title*80,rundate*24,
     *   datadate*24,oldname(nold)*8,fullname(nfull)*8,
     *   corrname(dimmax,dimmax)*8,rsetname(numrset)*12,
     *   splname(numspl)*12,distvar(numdist)*8,
     *   resname(sumdim)*12,parname(numpar)*12,gridfile*128
 
c     General information
      call writegeneral(amlversion,r2aversion,ipt,jpt,convcrit,amlfile,
     *   dsn,title,rundate,datadate)
 
c     Write frequency table of data structures and summarize how many
c     episodes have been used in the estimation.  Report sum of weights
c     and number of conditioning observations.
      call episused(datadim,nummodel,levelmax,datastructure,strucfreqs,
     *   minlnl,datanobs,nobs,wghtpos,sumweight,scaleweight,detail,
     *   oldname,ipt,jpt)
 
c     Write out all definitions and the model specifications.
      call write_model(levelmax,nfull,nummodel,numdist,sumdim,
     *   numrset,numspl,numpar,dimmax,datadim,maxref,mdllvl,distpos,
     *   distdim,distyp,distrestrpos,distrestr,resref,intpnts,
     *   rsetref,rsetbegin,rsetnum,maxxnode,
     *   parref,parpos,pardim,fulltype,splref,beginspl,nodepos,
     *   numnodes,spltype,datas,strctre,moel,
     *   moelpntr,modeltype,minlnl,namepntr,nold,
     *   maxnfreq,maxfreqcat,nfreq,freqloc,freqcat,freqs,
     *   originstats,rsetstats,xnode,detail,oldname,fullname,
     *   corrname,rsetname,splname,distvar,resname,
     *   parname,ipt,jpt,version,prof)
 
c     Write out the number of variables and starting values:
      call writestart(ngrid,nfull,iiffull,fullname,grid,fullbeta,
     *   gridpos,fulltype,gridfile,ipt,jpt)
 
c     Distyp was set to negative numbers for ARMA distributions of which
c     it should not be checked that time variables are increasing.  This
c     is no longer needed.
      call intvecabs(distyp,distyp,numdist)
 
  999 return
      end
